// FleetPick.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "FleetPick.h"
#include "FleetPickDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

ShipList gShipList;
ShipList gFighterList;

bool	sortFighters = false;
bool	operator < (Ship &s1, Ship &s)
{
	if (sortFighters)
	{
		if (s1.race == s.race)
			return s1.bpv < s.bpv;
		else
			return (s1.race < s.race);
	}
	else
	{
		if (s1.race == s.race)
		{
			if (s1.shipClass == s.shipClass) 
				return s1.bpv < s.bpv; 
			else 
				return (s1.shipClass < s.shipClass);
		}
		else
			return (s1.race < s.race);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CFleetPickApp

BEGIN_MESSAGE_MAP(CFleetPickApp, CWinApp)
	//{{AFX_MSG_MAP(CFleetPickApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFleetPickApp construction

CFleetPickApp::CFleetPickApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance

	gShipList.CreateMaster(ShipList::kOrionPirates, false);
	sortFighters = false;
	gShipList.sort();

/*	FILE *fp;
	fp = fopen("c:\\sadump.txt", "w");
	SHIP_LIST_ITER(gShipList)
		fprintf(fp, "%s\n", iter->shipCode.c_str());
	SHIP_LIST_ITER_END
	fclose(fp); */

	gFighterList = gShipList;
	std::list< eClassTypes > classList;
	classList.push_back(kClassPseudoFighter);
	classList.push_back(kClassShuttle);			// regular fighter
	gFighterList.Subset(classList);
	sortFighters = true;
	gFighterList.sort();

}

/////////////////////////////////////////////////////////////////////////////
// The one and only CFleetPickApp object

CFleetPickApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CFleetPickApp initialization

BOOL CFleetPickApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	CFleetPickDlg dlg;
	m_pMainWnd = &dlg;

	if (!stricmp(m_lpCmdLine, "/SECTORASSAULT"))
	{
		dlg.setMode(CFleetPickDlg::kBasePickMode);
		std::list< eClassTypes > classes;
		classes.push_back(kClassBaseStation);
		classes.push_back(kClassBattleStation);
		classes.push_back(kClassStarBase);
		gShipList.Subset(classes);

		std::list< eRace >	races;
		races.push_back(kNeutralRace);
	//	races.push_back(kOrion);			// allow Orion because cartels don't have bases!
		gShipList.Subset(races, false);		// exclude neutral and NPC race ships
	}
	else
	{
		dlg.setMode(CFleetPickDlg::kOrionPickMode);
		std::list< eRace > races;
		races.push_back(kOrion);
		gShipList.Subset(races);
		gShipList.SubsetPlayableShipClasses();
		sortFighters = false;
		gShipList.sort();
	}

	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}
