// FleetPickDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FleetPick.h"
#include "FleetPickDlg.h"
#include "PickShip.h"
#include "FleetPickContainer.h"
#include "SectorAssaultData.h"
#include "SerializableShipDesc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFleetPickDlg dialog

CFleetPickDlg::CFleetPickDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFleetPickDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFleetPickDlg)
	m_bpv1 = _T("");
	m_bpv2 = _T("");
	m_bpv3 = _T("");
	m_code1 = _T("");
	m_code2 = _T("");
	m_code3 = _T("");
	m_totalbpv = _T("");
	m_basedamage = 0;
	m_planetdamage = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	ship1picked = ship2picked = ship3picked = false;
	// Read from settings file here, when ready

	pickMode = kOrionPickMode;
}

void CFleetPickDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFleetPickDlg)
	DDX_Control(pDX, IDC_PLANET, m_planet);
	DDX_Control(pDX, IDC_FRDS, m_frds);
	DDX_Control(pDX, IDC_DEFSATS, m_defsats2);
	DDX_Control(pDX, IDLOAD, m_load);
	DDX_Text(pDX, IDC_SHIPBPV1, m_bpv1);
	DDX_Text(pDX, IDC_SHIPBPV2, m_bpv2);
	DDX_Text(pDX, IDC_SHIPBPV3, m_bpv3);
	DDX_Text(pDX, IDC_SHIPCODE1, m_code1);
	DDX_Text(pDX, IDC_SHIPCODE2, m_code2);
	DDX_Text(pDX, IDC_SHIPCODE3, m_code3);
	DDX_Text(pDX, IDC_TOTALBPV, m_totalbpv);
	DDX_Text(pDX, IDC_BASEDAMAGE, m_basedamage);
	DDX_Text(pDX, IDC_PLANETDAMAGE, m_planetdamage);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFleetPickDlg, CDialog)
	//{{AFX_MSG_MAP(CFleetPickDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDABOUT, OnAbout)
	ON_BN_CLICKED(IDC_SHIPSELECT1, OnShipSelect1)
	ON_BN_CLICKED(IDC_SHIPSELECT2, OnShipSelect2)
	ON_BN_CLICKED(IDC_SHIPSELECT3, OnShipSelect3)
	ON_BN_CLICKED(IDC_SHIPCLEAR1, OnShipClear1)
	ON_BN_CLICKED(IDC_SHIPCLEAR2, OnShipClear2)
	ON_BN_CLICKED(IDC_SHIPCLEAR3, OnShipClear3)
	ON_BN_CLICKED(IDLOAD, OnLoad)
	ON_BN_CLICKED(IDNOTORION, OnNotorion)
	ON_CBN_SELCHANGE(IDC_PLANET, OnSelchangePlanet)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFleetPickDlg message handlers

BOOL CFleetPickDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	if (pickMode == kBasePickMode)
	{
		::ShowWindow(GetDlgItem(IDC_SHIP2GROUP)->m_hWnd, SW_HIDE);
		::ShowWindow(GetDlgItem(IDC_SHIPCLEAR2)->m_hWnd, SW_HIDE);
		::ShowWindow(GetDlgItem(IDC_SHIPSELECT2)->m_hWnd, SW_HIDE);
		::ShowWindow(GetDlgItem(IDC_SHIP3GROUP)->m_hWnd, SW_HIDE);
		::ShowWindow(GetDlgItem(IDC_SHIPCLEAR3)->m_hWnd, SW_HIDE);
		::ShowWindow(GetDlgItem(IDC_SHIPSELECT3)->m_hWnd, SW_HIDE);

		::ShowWindow(GetDlgItem(IDC_BASEDEFSATSTR)->m_hWnd, SW_SHOW);
		::ShowWindow(GetDlgItem(IDC_DEFSATS)->m_hWnd, SW_SHOW);

		::ShowWindow(GetDlgItem(IDC_FRDSTR)->m_hWnd, SW_SHOW);
		::ShowWindow(GetDlgItem(IDC_FRDS)->m_hWnd, SW_SHOW);

		::ShowWindow(GetDlgItem(IDC_PLANETSTR)->m_hWnd, SW_SHOW);
		::ShowWindow(GetDlgItem(IDC_PLANET)->m_hWnd, SW_SHOW);

		m_defsats2.SetCurSel(0);
		m_frds.SetCurSel(0);
		m_planet.SetCurSel(0);
		m_basedamage = 0;
		m_planetdamage = 0;

		OnShipClear1();
		OnSelchangePlanet();
		ShowHideBaseDamage();

		SetWindowText("Sector Assault Configuration");

		UpdateData(FALSE);
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CFleetPickDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFleetPickDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFleetPickDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CFleetPickDlg::OnAbout() 
{
	ShowWindow(SW_HIDE);
	Sleep(25);	// prevent percieved flicker

	// TODO: Add your control notification handler code here
	CAboutDlg aDlg;
	aDlg.DoModal();

	ShowWindow(SW_SHOW);
}

void CFleetPickDlg::setMode(PickMode mode)
{
	pickMode = mode;
}

void CFleetPickDlg::OnShipSelect1() 
{
	// TODO: Add your control notification handler code here

	CPickShip	cps;

	cps.setMode(static_cast< CPickShip::PickMode >(pickMode));

	if (ship1picked)
		cps.Setup(ship1);
	else
		cps.Setup();

	char buf[64];
	
	switch (cps.DoModal())
	{
		case IDOK:
			ship1 = cps.GetSerializableShipDesc();
			m_code1 = ship1.shipCode;
			sprintf(buf, "%d", ship1.bpv_curr);
			m_bpv1 = buf;
			ship1picked = true;

			sprintf(buf, "%d",
				(ship1picked ? ship1.bpv_curr : 0) +
				(ship2picked ? ship2.bpv_curr : 0) +
				(ship2picked ? ship3.bpv_curr : 0));
			m_totalbpv = buf;

			UpdateData(FALSE);
			break;

		case IDCANCEL:
			break;
	}

	ShowHideBaseDamage();
}

void CFleetPickDlg::OnShipSelect2() 
{
	// TODO: Add your control notification handler code here
	
	if (!ship1picked)
	{
		OnShipSelect1();
		return;
	}

	CPickShip	cps;

	cps.setMode(static_cast< CPickShip::PickMode >(pickMode));

	if (ship2picked)
		cps.Setup(ship2);
	else
		cps.Setup();

	char buf[64];
	
	switch (cps.DoModal())
	{
		case IDOK:
			ship2 = cps.GetSerializableShipDesc();
			m_code2 = ship2.shipCode;
			sprintf(buf, "%d", ship2.bpv_curr);
			m_bpv2 = buf;
			ship2picked = true;

			sprintf(buf, "%d",
				(ship1picked ? ship1.bpv_curr : 0) +
				(ship2picked ? ship2.bpv_curr : 0) +
				(ship2picked ? ship3.bpv_curr : 0));
			m_totalbpv = buf;

			UpdateData(FALSE);
			break;

		case IDCANCEL:
			break;
	}
}

void CFleetPickDlg::OnShipSelect3() 
{
	// TODO: Add your control notification handler code here
	
	if (!ship1picked)
	{
		OnShipSelect1();
		return;
	}

	if (!ship2picked)
	{
		OnShipSelect2();
		return;
	}

	CPickShip	cps;

	cps.setMode(static_cast< CPickShip::PickMode >(pickMode));

	if (ship3picked)
		cps.Setup(ship3);
	else
		cps.Setup();

	char buf[64];
	
	switch (cps.DoModal())
	{
		case IDOK:
			ship3 = cps.GetSerializableShipDesc();
			m_code3 = ship3.shipCode;
			sprintf(buf, "%d", ship3.bpv_curr);
			m_bpv3 = buf;
			ship3picked = true;

			sprintf(buf, "%d",
				(ship1picked ? ship1.bpv_curr : 0) +
				(ship2picked ? ship2.bpv_curr : 0) +
				(ship2picked ? ship3.bpv_curr : 0));
			m_totalbpv = buf;

			UpdateData(FALSE);
			break;

		case IDCANCEL:
			break;
	}
}

void CFleetPickDlg::OnShipClear1() 
{
	// TODO: Add your control notification handler code here
	
	ship1picked = false;
	ship1.Reset();

	m_code1 = "";
	m_bpv1 = "";

	ShowHideBaseDamage();
	UpdateData(FALSE);
}

void CFleetPickDlg::OnShipClear2() 
{
	// TODO: Add your control notification handler code here
	
	ship2picked = false;
	ship2.Reset();

	m_code2 = "";
	m_bpv2 = "";
	UpdateData(FALSE);
}

void CFleetPickDlg::OnShipClear3() 
{
	// TODO: Add your control notification handler code here
	
	ship3picked = false;
	ship3.Reset();

	m_code3 = "";
	m_bpv3 = "";
	UpdateData(FALSE);
}

void CFleetPickDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	FILE *fp;

	fp = fopen("C:\\FleetPick.FLT", "wb");

	if (!fp)
	{
		MessageBox("Aack, could not write to C:\\FleetPick.FLT!");
	}
	else
	{
		int ships = 0;
		int version = SSD_REVISION;
		if (ship1picked) ships++;
		if (ship2picked) ships++;
		if (ship3picked) ships++;

		fwrite(&version, sizeof(int), 1, fp);
		fwrite(&ships, sizeof(int), 1, fp);
		if (ship1picked) ship1.Write(fp); 
		if (ship2picked) ship2.Write(fp); 
		if (ship3picked) ship3.Write(fp);
		fclose(fp);

		MessageBox("Fleet saved... you will now play this fleet in your next battle.");
	}

	UpdateData(TRUE);

	SectorAssaultData	sad;
	sad.mSetDefSats(m_defsats2.GetCurSel());
	sad.mSetFRDs(m_frds.GetCurSel());
	sad.mSetPlanetType(m_planet.GetCurSel());
	sad.mSetPercentBaseDamage(m_basedamage);
	sad.mSetPercentPlanetDamage(m_planetdamage);
	sad.Save();

	CDialog::OnOK();
}

void CFleetPickDlg::OnLoad() 
{
	// TODO: Add your control notification handler code here
	
	FleetPickContainer fpc;
	int c = fpc.getShipCount();
	char buf[64];

	SectorAssaultData	sad;
	sad.Load();

	m_defsats2.SetCurSel(sad.mGetDefSats());
	m_frds.SetCurSel(sad.mGetFRDs());
	m_planet.SetCurSel(sad.mGetPlanetType());
	m_basedamage = sad.mGetPercentBaseDamage();
	m_planetdamage = sad.mGetPercentPlanetDamage();

	if (c--)	// ironic?
	{
		ship1 = fpc.getSSD(1);
		m_code1 = ship1.shipCode;
		sprintf(buf, "%d", ship1.bpv_curr);
		m_bpv1 = buf;
		ship1picked = true;

		sprintf(buf, "%d",
			(ship1picked ? ship1.bpv_curr : 0) +
			(ship2picked ? ship2.bpv_curr : 0) +
			(ship2picked ? ship3.bpv_curr : 0));
		m_totalbpv = buf;
	}
	else
	{
		OnSelchangePlanet();
		ShowHideBaseDamage();
		ship1picked = false;
		UpdateData(FALSE);
		return;
	}

	OnSelchangePlanet();
	ShowHideBaseDamage();

	if (c--)	// ironic?
	{
		ship2 = fpc.getSSD(2);
		m_code2 = ship2.shipCode;
		sprintf(buf, "%d", ship2.bpv_curr);
		m_bpv2 = buf;
		ship2picked = true;

		sprintf(buf, "%d",
			(ship1picked ? ship1.bpv_curr : 0) +
			(ship2picked ? ship2.bpv_curr : 0) +
			(ship2picked ? ship3.bpv_curr : 0));
		m_totalbpv = buf;
	}
	else
	{
		UpdateData(FALSE);
		return;
	}

	if (c--)	// ironic?
	{
		ship3 = fpc.getSSD(3);
		m_code3 = ship3.shipCode;
		sprintf(buf, "%d", ship3.bpv_curr);
		m_bpv3 = buf;
		ship1picked = true;

		sprintf(buf, "%d",
			(ship1picked ? ship1.bpv_curr : 0) +
			(ship2picked ? ship2.bpv_curr : 0) +
			(ship2picked ? ship3.bpv_curr : 0));
		m_totalbpv = buf;
	}

	UpdateData(FALSE);
}

void CFleetPickDlg::OnNotorion() 
{
	// TODO: Add your control notification handler code here
	
	FILE *fp = fopen("C:\\FleetPick.FLT", "r");
	if (fp)
	{
		fclose(fp);
		if (MessageBox("Are you sure you want to erase your custom fleet settings?", "Question", MB_YESNO | MB_ICONQUESTION) == IDYES)
			remove("C:\\FleetPick.FLT");
		else
		{
			MessageBox("Your custom fleet settings were not erased.");
			return;
		}
	}
	
	MessageBox("Your custom fleet settings have been erased.\nYour in-game fleet selection will be used in your next match.");
}

void CFleetPickDlg::OnSelchangePlanet() 
{
	if (m_planet.GetCurSel() == 0)
	{
		::ShowWindow(GetDlgItem(IDC_PLANETDAMAGESTR)->m_hWnd, SW_HIDE);
		::ShowWindow(GetDlgItem(IDC_PLANETDAMAGEPCT)->m_hWnd, SW_HIDE);
		::ShowWindow(GetDlgItem(IDC_PLANETDAMAGE)->m_hWnd, SW_HIDE);
	}
	else
	{
		::ShowWindow(GetDlgItem(IDC_PLANETDAMAGESTR)->m_hWnd, SW_SHOW);
		::ShowWindow(GetDlgItem(IDC_PLANETDAMAGEPCT)->m_hWnd, SW_SHOW);
		::ShowWindow(GetDlgItem(IDC_PLANETDAMAGE)->m_hWnd, SW_SHOW);
	}
}

void CFleetPickDlg::ShowHideBaseDamage(void)
{
	if (!ship1picked)
	{
		::ShowWindow(GetDlgItem(IDC_BASEDAMAGESTR)->m_hWnd, SW_HIDE);
		::ShowWindow(GetDlgItem(IDC_BASEDAMAGEPCT)->m_hWnd, SW_HIDE);
		::ShowWindow(GetDlgItem(IDC_BASEDAMAGE)->m_hWnd, SW_HIDE);
	}
	else
	{
		::ShowWindow(GetDlgItem(IDC_BASEDAMAGESTR)->m_hWnd, SW_SHOW);
		::ShowWindow(GetDlgItem(IDC_BASEDAMAGEPCT)->m_hWnd, SW_SHOW);
		::ShowWindow(GetDlgItem(IDC_BASEDAMAGE)->m_hWnd, SW_SHOW);
	}
}
