// FleetPickDlg.h : header file
//

#if !defined(AFX_FLEETPICKDLG_H__F578A662_2D32_43B5_82E9_E97988E8AC17__INCLUDED_)
#define AFX_FLEETPICKDLG_H__F578A662_2D32_43B5_82E9_E97988E8AC17__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "StdAfx.h"
#include "SerializableShipDesc.h"

/////////////////////////////////////////////////////////////////////////////
// CFleetPickDlg dialog

class CFleetPickDlg : public CDialog
{
// Construction
public:
	CFleetPickDlg(CWnd* pParent = NULL);	// standard constructor

	typedef enum
	{
		kOrionPickMode,
		kBasePickMode
	} PickMode;

	void setMode(PickMode);

// Dialog Data
	//{{AFX_DATA(CFleetPickDlg)
	enum { IDD = IDD_FLEETPICK_DIALOG };
	CComboBox	m_planet;
	CComboBox	m_frds;
	CComboBox	m_defsats2;
	CButton	m_load;
	CListBox	m_defsats;
	CString	m_bpv1;
	CString	m_bpv2;
	CString	m_bpv3;
	CString	m_code1;
	CString	m_code2;
	CString	m_code3;
	CString	m_totalbpv;
	int		m_basedamage;
	int		m_planetdamage;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFleetPickDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CFleetPickDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnAbout();
	afx_msg void OnShipSelect1();
	afx_msg void OnShipSelect2();
	afx_msg void OnShipSelect3();
	afx_msg void OnShipClear1();
	afx_msg void OnShipClear2();
	afx_msg void OnShipClear3();
	virtual void OnOK();
	afx_msg void OnLoad();
	afx_msg void OnNotorion();
	afx_msg void OnSelchangePlanet();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:

	bool					ship1picked;
	SerializableShipDesc	ship1;

	bool					ship2picked;
	SerializableShipDesc	ship2;

	bool					ship3picked;
	SerializableShipDesc	ship3;

	PickMode				pickMode;

	void	Initialize();
	void	Recalculate();
	void	ShowHideBaseDamage(void);

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FLEETPICKDLG_H__F578A662_2D32_43B5_82E9_E97988E8AC17__INCLUDED_)
