/*
 * PickShip.cpp
 *
 * Pick Ship Dialog.
 *
 * (C) 2001 MagnumMan-iCoP (James E. King, III)
 */

#include "stdafx.h"
#include "FleetPick.h"
#include "PickShip.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPickShip dialog


CPickShip::CPickShip(CWnd* pParent /*=NULL*/)
	: CDialog(CPickShip::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPickShip)
	m_bpv = _T("");
	m_bpv_adj = _T("");
	m_drone_size = _T("");
	m_drone_speed = _T("");
	m_drone_count = 0;
	m_marines = 0;
	m_mines = 0;
	m_repairs = 0;
	m_shield_1 = _T("");
	m_shield_4 = _T("");
	m_ship_code = _T("");
	m_shuttles_max = _T("");
	m_shuttles = 0;
	m_weaponry_desc = _T("");
	m_ship_class = _T("");
	m_fighter_bays = 0;
	m_fighter_cost = _T("");
	m_fighter_type = _T("");
	m_shield_2 = _T("");
	m_shield_3 = _T("");
	m_shield_5 = _T("");
	m_shield_6 = _T("");
	m_fighter_count = 0;
	//}}AFX_DATA_INIT

	sl = gShipList;
	sli = sl.begin();
}

void CPickShip::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPickShip)
	DDX_Text(pDX, IDC_BPV, m_bpv);
	DDX_Text(pDX, IDC_BPVADJ, m_bpv_adj);
	DDX_Text(pDX, IDC_DRONETYPE, m_drone_size);
	DDX_Text(pDX, IDC_DRONESPEED, m_drone_speed);
	DDX_Text(pDX, IDC_DRONECOUNT, m_drone_count);
	DDX_Text(pDX, IDC_MARINES, m_marines);
	DDX_Text(pDX, IDC_MINES, m_mines);
	DDX_Text(pDX, IDC_REPAIRS, m_repairs);
	DDX_Text(pDX, IDC_SHIELD1, m_shield_1);
	DDX_Text(pDX, IDC_SHIELD4, m_shield_4);
	DDX_Text(pDX, IDC_SHIPCODE, m_ship_code);
	DDX_Text(pDX, IDC_SHUTTLEMAX, m_shuttles_max);
	DDX_Text(pDX, IDC_SHUTTLES, m_shuttles);
	DDX_Text(pDX, IDC_WEAPONRY, m_weaponry_desc);
	DDX_Text(pDX, IDC_CLASS, m_ship_class);
	DDX_Text(pDX, IDC_FIGHTERBAYS, m_fighter_bays);
	DDX_Text(pDX, IDC_FIGHTERCOST1, m_fighter_cost);
	DDX_Text(pDX, IDC_FIGHTER1, m_fighter_type);
	DDX_Text(pDX, IDC_SHIELD2n, m_shield_2);
	DDX_Text(pDX, IDC_SHIELD3n, m_shield_3);
	DDX_Text(pDX, IDC_SHIELD5n, m_shield_5);
	DDX_Text(pDX, IDC_SHIELD6n, m_shield_6);
	DDX_Text(pDX, IDC_FIGHTERNUM1, m_fighter_count);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPickShip, CDialog)
	//{{AFX_MSG_MAP(CPickShip)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SHIPSPIN, OnDeltaposShipspin)
	ON_WM_CREATE()
	ON_NOTIFY(UDN_DELTAPOS, IDC_MARINESSPIN, OnDeltaposMarinesspin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_MINESSPIN, OnDeltaposMinesspin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SHUTTLESPIN, OnDeltaposShuttlespin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_REPAIRSSPIN, OnDeltaposRepairsspin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_DRONECOUNTSPIN, OnDeltaposDronecountspin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_DRONETYPESPIN, OnDeltaposDronetypespin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_DRONESPEEDSPIN, OnDeltaposDronespeedspin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_FIGHTERNUMSPIN1, OnDeltaposFighternumspin1)
	ON_NOTIFY(UDN_DELTAPOS, IDC_FIGHTERSPIN1, OnDeltaposFighterspin1)
	ON_BN_CLICKED(IDC_FS1, OnFs1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPickShip message handlers

SerializableShipDesc CPickShip::GetSerializableShipDesc()
{
	// UpdateData not necessary, this is called after OK button

	SerializableShipDesc ssd;

	strcpy(ssd.shipCode, m_ship_code);
	ssd.bpv_base = atoi(m_bpv);
	ssd.bpv_curr = atoi(m_bpv_adj);

	ssd.shuttles = m_shuttles;

	ssd.marines = m_marines;
	ssd.mines = m_mines;
	ssd.repairs = m_repairs;									// ?????????????????????

	ssd.drone_size = (m_drone_size == "Type I") ? 1 : 4;			// 1 = Type I (small); 4 = Type IV (heavy)
	if (m_drone_speed == "Slow") ssd.drone_speed = 1;
	else ssd.drone_speed = (m_drone_speed == "Medium") ? 2 : 3;
	ssd.drone_reloads = drone_reloads;

	strcpy(ssd.fighter_type, m_fighter_type);
	ssd.fighter_count = m_fighter_count;
	ssd.fighter_bays  = m_fighter_bays;
	
	return ssd;		// Will make a copy on the return stack
}

void CPickShip::Setup(SerializableShipDesc &ssd)
{
	char buf[64];

	for (sli = sl.begin(); sli != sl.end(); sli++)
	{
		if (!sli->shipCode.compare(ssd.shipCode))
		{
			Initialize();
			break;
		}
	}

	m_shuttles = ssd.shuttles;
	m_marines = ssd.marines;
	m_mines = ssd.mines;
	m_repairs = ssd.repairs;

	m_drone_size = (ssd.drone_size == 1) ? "Type I" : "Type IV";
	if (ssd.drone_speed == 1) m_drone_speed = "Slow";
	else m_drone_speed = (ssd.drone_speed == 2) ? "Medium" : "Fast";
	drone_reloads = ssd.drone_reloads;
	if (m_drone_size == "Type IV")
		drones_per_reload /= 2;

	if (ssd.fighter_count && ssd.fighter_bays)
	{
		m_fighter_bays = ssd.fighter_bays;
		m_fighter_count = ssd.fighter_count;

		for (RealShipListIter riter = gFighterList.begin(); riter != gFighterList.end(); riter++)
		{
			if (riter->shipCode.compare(ssd.fighter_type) == 0)
			{
				fiter[0] = riter;
				m_fighter_type = fiter[0]->shipCode.c_str();
				sprintf(buf, "%d", fiter[0]->bpv * ssd.fighter_count * ssd.fighter_bays);
				m_fighter_cost = buf;
				break;
			}
		}
	}
}

void CPickShip::Initialize(void)
{
	char	buf[64];

	sprintf(buf, "%d", sli->bpv);
	m_bpv = buf;
	m_ship_code = sli->shipCode.c_str();

	cur_class = sli->shipClass;

	switch (sli->shipClass)
	{
		case kClassFrigate:				m_ship_class = "Frigate"; break;
		case kClassDestroyer:			m_ship_class = "Destroyer"; break;
		case kClassWarDestroyer:		m_ship_class = "War Destroyer"; break;
		case kClassLightCruiser:		m_ship_class = "Light Cruiser"; break;
		case kClassHeavyCruiser:		m_ship_class = "Heavy Cruiser"; break;
		case kClassNewHeavyCruiser:		m_ship_class = "New Heavy Cruiser"; break;
		case kClassHeavyBattlecruiser:	m_ship_class = "Heavy Battlecruiser"; break;
		case kClassCarrier:				m_ship_class = "Carrier"; break;
		case kClassDreadnought:			m_ship_class = "Dreadnought"; break;
		case kClassBattleship:			m_ship_class = "Battleship"; break;
		case kClassBaseStation:			m_ship_class = "Base Station"; break;
		case kClassBattleStation:		m_ship_class = "Battle Station"; break;
		case kClassStarBase:			m_ship_class = "Star Base"; break;
	}

	sprintf(buf, "%d", sli->shields[kForeShieldIndex]);
	m_shield_1 = buf;
	sprintf(buf, "%d", sli->shields[kLeftForeShieldIndex]);
	m_shield_2 = buf;
	sprintf(buf, "%d", sli->shields[kLeftAftShieldIndex]);
	m_shield_3 = buf;
	sprintf(buf, "%d", sli->shields[kAftShieldIndex]);
	m_shield_4 = buf;
	sprintf(buf, "%d", sli->shields[kRightAftShieldIndex]);
	m_shield_5 = buf;
	sprintf(buf, "%d", sli->shields[kRightForeShieldIndex]);
	m_shield_6 = buf;

	m_marines = sli->marinesBase;
	m_mines = sli->tBombsBase;
	m_repairs = sli->damageControl;

	m_shuttles = sli->adminBase;
	sprintf(buf, "%d", sli->adminMax);
	m_shuttles_max = buf;

	//
	// Here we initialize the "Weaponry" descriptor
	//

	m_weaponry_desc = "";
	drones_per_reload = 0;
	drone_reloads = 0;

	for (int ssti = static_cast<int>(kShipSystemWeaponMinValue);
			 ssti < static_cast<int>(kShipSystemNumberOfWeapons);
			 ssti++)
	{
		eShipSystemType sst = static_cast<eShipSystemType>(ssti);
		int weaponCount = 0;

		for (WeaponsIter wi = sli->weapons.begin(); wi != sli->weapons.end(); wi++)
		{
			if (wi->second.weaponType == sst)
				weaponCount += wi->second.count;
		}

		if (weaponCount)
		{
			char buf[64];
			char type[32];
			int dpr = 0;

			switch (sst)
			{
				case kShipSystemPhoton: strcpy(type, "Phot"); break;
				case kShipSystemPhotonFighter: strcpy(type, "PhoF"); break;
				case kShipSystemHeavyPhoton: strcpy(type, "PhoH"); break;
				case kShipSystemDisruptor1: strcpy(type, "Dis1"); break;
				case kShipSystemDisruptor2: strcpy(type, "Dis2"); break;
				case kShipSystemDisruptor3: strcpy(type, "Dis3"); break;
				case kShipSystemDisruptor4: strcpy(type, "Dis4"); break;
				case kShipSystemDisruptorFighter: strcpy(type, "DisF"); break;
				case kShipSystemHeavyDisruptor: strcpy(type, "DisH"); break;
				case kShipSystemFusion: strcpy(type, "Fus"); break;
				case kShipSystemFusionFighter: strcpy(type, "FusF"); break;
				case kShipSystemHellbore: strcpy(type, "HB"); break;
				case kShipSystemHellboreFighter: strcpy(type, "HellF"); break;
				case kShipSystemPlasmaR: strcpy(type, "PlaR"); break;
				case kShipSystemPlasmaS: strcpy(type, "PlaS"); break;
				case kShipSystemPlasmaG: strcpy(type, "PlaG"); break;
				case kShipSystemPlasmaF: strcpy(type, "PlaF"); break;
				case kShipSystemPlasmaI: strcpy(type, "PlaI"); break;
				case kShipSystemPlasmaD: strcpy(type, "PlaD"); break;
				case kShipSystemPlasmaE: strcpy(type, "PlaE"); break;
				case kShipSystemPlasmaX: strcpy(type, "PlaX"); break;
				case kShipSystemESG: strcpy(type, "ESG"); break;
				case kShipSystemESGLance: strcpy(type, "ESGL"); break;
				case kShipSystemPPD: strcpy(type, "PPD"); break;
				case kShipSystemMauler: strcpy(type, "MLR"); break;
				case kShipSystemPhaserA: strcpy(type, "PhA"); break;
				case kShipSystemPhaserB: strcpy(type, "PhB"); break;
				case kShipSystemTRBeam: strcpy(type, "TRB"); break;
				case kShipSystemShuttleWeapon: strcpy(type, "ShutW"); break;
				case kShipSystemFighterSystem: strcpy(type, "FighS"); break;
				case kShipSystemDroneRackA: strcpy(type, "DroA"); dpr = 4; break;
				case kShipSystemDroneRackB: strcpy(type, "DroB"); dpr = 6; break;
				case kShipSystemDroneRackC: strcpy(type, "DroC"); dpr = 4; break;
				case kShipSystemDroneRackD: strcpy(type, "DroD"); dpr = 4; break;
				case kShipSystemDroneRackE: strcpy(type, "DroE"); dpr = 4; break;
				case kShipSystemDroneRackF: strcpy(type, "DroF"); dpr = 4; break;
				case kShipSystemDroneRackG: strcpy(type, "DroG"); dpr = 4; break;
				case kShipSystemDroneRackH: strcpy(type, "DroH"); dpr = 12; break;		// a guess
				case kShipSystemDroneFighter1: strcpy(type, "DroF1"); break;
				case kShipSystemDroneFighter4: strcpy(type, "DroF4"); break;
				case kShipSystemDroneRackMIRV: strcpy(type, "DroM"); dpr = 6; break;
				case kShipSystemOptional: strcpy(type, "Opt"); break;
				case kShipSystemOptionalW: strcpy(type, "OptW"); break;
				case kShipSystemPhaser1: strcpy(type, "Ph1"); break;
				case kShipSystemPhaser2: strcpy(type, "Ph2"); break;
				case kShipSystemPhaser3: strcpy(type, "Ph3"); break;
				case kShipSystemPhaserG: strcpy(type, "PhG"); break;
				case kShipSystemPhaserG2: strcpy(type, "PhG2"); break;
				case kShipSystemPhaser4: strcpy(type, "Ph4"); break;
				case kShipSystemPhaserX: strcpy(type, "PhX"); break;
				case kShipSystemADD6: strcpy(type, "ADD6"); break;
				case kShipSystemADD12: strcpy(type, "ADD12"); break;
				case kShipSystemADD30: strcpy(type, "ADD30"); break;
				default:  strcpy(type, "Unknown"); break;
			}

			sprintf(buf, "%dx%s\n", weaponCount, type);
			m_weaponry_desc += buf;
			drones_per_reload += (weaponCount * dpr);
		}
	}

	if (drones_per_reload)
		drone_reloads = 1;

	m_drone_size = "Type I";
	m_drone_speed = "Slow";

	m_fighter_bays = 0;
	m_fighter_type = "";
	m_fighter_count = 0;
	m_fighter_cost = "";

	fighter_base_bpv = 0;

	for (int k = 0; k < 4; k++)
	{
		if (sli->fighters[k].second)	// count
		{
			m_fighter_bays++;

			for (RealShipListIter riter = gFighterList.begin(); riter != gFighterList.end(); riter++)
			{
				if (riter->shipCode.compare(sli->fighters[k].first.shipCode) == 0)
				{
					fiter[k] = riter;

					switch (k)
					{
						case 0:
							m_fighter_type = fiter[k]->shipCode.c_str();
							m_fighter_count = sli->fighters[k].second;

						case 1:
						case 2:
						case 3:
							fighter_base_bpv += fiter[k]->bpv * sli->fighters[k].second;
							break;
						
						default:
							break;
					}
				}
			}
		}
	}

	if (fighter_base_bpv)
	{
		sprintf(buf, "%d", fighter_base_bpv);
		m_fighter_cost = buf;
	}
}

void CPickShip::Recalculate(bool redraw)
{
	char buf[64];

	//
	// Calculate drones
	//
	
	m_drone_count = drones_per_reload * (drone_reloads + 1);		// Ships come with one reload standard
	
	//
	// Calculate adjusted BPV here
	//

	int newBPV = sli->bpv;
	newBPV += (m_marines - sli->marinesBase) * 2;
	newBPV += (m_mines - sli->tBombsBase) * 4;
	newBPV += (m_repairs - sli->damageControl) * 4;
	newBPV += (m_shuttles - sli->adminBase) * 1;	// kinda low cost for shuttles, EH?
	if (m_drone_speed == "Medium")
		newBPV += (m_drone_count * 0.5);			// nice -n- cheap
	else if (m_drone_speed == "Fast")
		newBPV += (m_drone_count * 1);

	newBPV += atoi(m_fighter_cost);	
	newBPV -= fighter_base_bpv;
	
	sprintf(buf, "%d", newBPV);
	m_bpv_adj = buf;

	if (redraw)
		UpdateData(FALSE);
}

void CPickShip::OnDeltaposShipspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	
	*pResult = 0;

	if (pNMUpDown->iDelta < 0)
	{
		if (++sli == sl.end())
		{
			--sli;
			return;				// do not allow movement
		}

		Initialize();
		Recalculate();
	}
	else if (pNMUpDown->iDelta > 0)
	{
		if (sli == sl.begin())
			return;				// do not allow movement

		--sli;
		Initialize();
		Recalculate();
	}

	*pResult = 1;
}

int CPickShip::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	
	Recalculate(false);

	return 0;
}

void CPickShip::OnDeltaposMarinesspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	
	*pResult = 0;

	UpdateData(TRUE);

	if (pNMUpDown->iDelta < 0)
	{
		if (m_marines == sli->marinesMax)
			return;				// do not allow movement

		m_marines++;
		Recalculate();
	}
	else if (pNMUpDown->iDelta > 0)
	{
		if (m_marines == sli->marinesBase)
			return;				// do not allow movement

		m_marines--;
		Recalculate();
	}

	*pResult = 1;
}

void CPickShip::OnDeltaposMinesspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	
	*pResult = 0;

	UpdateData(TRUE);

	if (pNMUpDown->iDelta < 0)
	{
		if (m_mines == sli->tBombsMax)
			return;				// do not allow movement

		m_mines++;
		Recalculate();
	}
	else if (pNMUpDown->iDelta > 0)
	{
		if (m_mines == sli->tBombsBase)
			return;				// do not allow movement

		m_mines--;
		Recalculate();
	}

	*pResult = 1;
}

void CPickShip::OnDeltaposShuttlespin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	
	*pResult = 0;

	UpdateData(TRUE);

	if (pNMUpDown->iDelta < 0)
	{
		if (m_shuttles == sli->adminMax)
			return;				// do not allow movement

		m_shuttles++;
		Recalculate();
	}
	else if (pNMUpDown->iDelta > 0)
	{
		if (m_shuttles == sli->adminBase)
			return;				// do not allow movement

		m_shuttles--;
		Recalculate();
	}

	*pResult = 1;
}

void CPickShip::OnDeltaposRepairsspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	
	*pResult = 0;

	UpdateData(TRUE);

	if (pNMUpDown->iDelta < 0)
	{
		if (m_repairs == sli->damageControl * 4)
			return;				// do not allow movement

		m_repairs++;
		Recalculate();
	}
	else if (pNMUpDown->iDelta > 0)
	{
		if (m_repairs == sli->damageControl)
			return;				// do not allow movement

		m_repairs--;
		Recalculate();
	}

	*pResult = 1;
}

void CPickShip::OnDeltaposDronecountspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	
	*pResult = 0;

	UpdateData(TRUE);

	if (pNMUpDown->iDelta < 0)
	{
		if (drone_reloads == 4)
			return;				// do not allow movement

		drone_reloads++;
		Recalculate();
	}
	else if (pNMUpDown->iDelta > 0)
	{
		if (drone_reloads == 1)
			return;				// do not allow movement

		drone_reloads--;
		Recalculate();
	}

	*pResult = 1;
}

void CPickShip::OnDeltaposDronetypespin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	
	*pResult = 0;

	if (pNMUpDown->iDelta < 0)
	{
		if (m_drone_size == "Type IV")
			return;				// do not allow movement

		m_drone_size = "Type IV";
		drones_per_reload /= 2;
		
		Recalculate();
	}
	else if (pNMUpDown->iDelta > 0)
	{
		if (m_drone_size == "Type I")
			return;				// do not allow movement

		m_drone_size = "Type I";
		drones_per_reload *= 2;
		
		Recalculate();
	}

	*pResult = 1;
}

void CPickShip::OnDeltaposDronespeedspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	
	*pResult = 0;

	if (pNMUpDown->iDelta < 0)
	{
		if (m_drone_size == "Fast")
			return;				// do not allow movement

		if (m_drone_speed == "Slow")
			m_drone_speed = "Medium";
		else
			m_drone_speed = "Fast";
		
		Recalculate();
	}
	else if (pNMUpDown->iDelta > 0)
	{
		if (m_drone_size == "Slow")
			return;				// do not allow movement

		if (m_drone_speed == "Fast")
			m_drone_speed = "Medium";
		else
			m_drone_speed = "Slow";
		
		Recalculate();
	}

}

void CPickShip::OnDeltaposFighternumspin1(NMHDR* pNMHDR, LRESULT* pResult)
{
	OnDeltaposFighternumspinCOMMON(0, pNMHDR, pResult);
}

void CPickShip::OnDeltaposFighternumspin2(NMHDR* pNMHDR, LRESULT* pResult)
{
	OnDeltaposFighternumspinCOMMON(1, pNMHDR, pResult);
}

void CPickShip::OnDeltaposFighternumspin3(NMHDR* pNMHDR, LRESULT* pResult)
{
	OnDeltaposFighternumspinCOMMON(2, pNMHDR, pResult);
}

void CPickShip::OnDeltaposFighternumspin4(NMHDR* pNMHDR, LRESULT* pResult)
{
	OnDeltaposFighternumspinCOMMON(3, pNMHDR, pResult);
}

void CPickShip::OnDeltaposFighternumspinCOMMON(int num, NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	
	*pResult = 0;

	char buf[64];

	if (!m_fighter_bays) return;

	if (pNMUpDown->iDelta < 0)
	{
		if (m_fighter_count == ((fiter[num]->shipClass == kClassShuttle) ? 4 : 1))
			return;		// maxed out
		
		m_fighter_count++;
		sprintf(buf, "%d", fiter[num]->bpv * m_fighter_count * m_fighter_bays);
		m_fighter_cost = buf;

		Recalculate();
	}
	else if (pNMUpDown->iDelta > 0)
	{
		if (m_fighter_count <= 1)
			return;		// do not allow movement

		m_fighter_count--;
		sprintf(buf, "%d", fiter[num]->bpv * m_fighter_count * m_fighter_bays);
		m_fighter_cost = buf;

		Recalculate();
	}

	*pResult = 1;
}

void CPickShip::OnDeltaposFighterspin1(NMHDR* pNMHDR, LRESULT* pResult)
{
	OnDeltaposFighterspinCOMMON(0, pNMHDR, pResult);
}

void CPickShip::OnDeltaposFighterspinCOMMON(int num, NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	
	*pResult = 0;

	char buf[64];

	if (!m_fighter_count || !m_fighter_bays) return;

	if (pNMUpDown->iDelta < 0)
	{
		RealShipListIter	rsli = fiter[num];

		if (++rsli == gFighterList.end())
			return;		// do not allow movement

		if (rsli->race != sli->race)
		{
			--rsli;
			return;		// different race...
		}

		fiter[num]++;		// move forward in the list
		
		m_fighter_type = fiter[num]->shipCode.c_str();
		sprintf(buf, "%d", fiter[num]->bpv * m_fighter_count * m_fighter_bays);
		m_fighter_cost = buf;

		Recalculate();
	}
	else if (pNMUpDown->iDelta > 0)
	{
		if (fiter[num] == gFighterList.begin())
			return;		// do not allow movement

		fiter[num]--;		// move backwards in the list
		
		if (fiter[num]->race != sli->race)
		{
			fiter[num]++;
			return;		// different race...
		}

		m_fighter_type = fiter[num]->shipCode.c_str();
		sprintf(buf, "%d", fiter[num]->bpv * m_fighter_count * m_fighter_bays);
		m_fighter_cost = buf;

		Recalculate();
	}

	*pResult = 1;
}

void CPickShip::FighterSpecs(int num)
{
	RealShipListIter	rsli;
	rsli = fiter[num];

	CString w_desc;

	w_desc = rsli->shipCode.c_str();
	w_desc += ":\n\n";

	for (int ssti = static_cast<int>(kShipSystemWeaponMinValue);
			 ssti < static_cast<int>(kShipSystemNumberOfWeapons);
			 ssti++)
	{
		eShipSystemType sst = static_cast<eShipSystemType>(ssti);
		int weaponCount = 0;

		for (WeaponsIter wi = rsli->weapons.begin(); wi != rsli->weapons.end(); wi++)
		{
			if (wi->second.weaponType == sst)
				weaponCount += wi->second.count;
		}

		if (weaponCount)
		{
			char buf[64];
			char type[32];
			int dpr = 0;

			switch (sst)
			{
				case kShipSystemPhoton: strcpy(type, "Phot"); break;
				case kShipSystemPhotonFighter: strcpy(type, "PhoF"); break;
				case kShipSystemHeavyPhoton: strcpy(type, "PhoH"); break;
				case kShipSystemDisruptor1: strcpy(type, "Dis1"); break;
				case kShipSystemDisruptor2: strcpy(type, "Dis2"); break;
				case kShipSystemDisruptor3: strcpy(type, "Dis3"); break;
				case kShipSystemDisruptor4: strcpy(type, "Dis4"); break;
				case kShipSystemDisruptorFighter: strcpy(type, "DisF"); break;
				case kShipSystemHeavyDisruptor: strcpy(type, "DisH"); break;
				case kShipSystemFusion: strcpy(type, "Fus"); break;
				case kShipSystemFusionFighter: strcpy(type, "FusF"); break;
				case kShipSystemHellbore: strcpy(type, "HB"); break;
				case kShipSystemHellboreFighter: strcpy(type, "HellF"); break;
				case kShipSystemPlasmaR: strcpy(type, "PlaR"); break;
				case kShipSystemPlasmaS: strcpy(type, "PlaS"); break;
				case kShipSystemPlasmaG: strcpy(type, "PlaG"); break;
				case kShipSystemPlasmaF: strcpy(type, "PlaF"); break;
				case kShipSystemPlasmaI: strcpy(type, "PlaI"); break;
				case kShipSystemPlasmaD: strcpy(type, "PlaD"); break;
				case kShipSystemPlasmaE: strcpy(type, "PlaE"); break;
				case kShipSystemPlasmaX: strcpy(type, "PlaX"); break;
				case kShipSystemESG: strcpy(type, "ESG"); break;
				case kShipSystemESGLance: strcpy(type, "ESGL"); break;
				case kShipSystemPPD: strcpy(type, "PPD"); break;
				case kShipSystemMauler: strcpy(type, "MLR"); break;
				case kShipSystemPhaserA: strcpy(type, "PhA"); break;
				case kShipSystemPhaserB: strcpy(type, "PhB"); break;
				case kShipSystemTRBeam: strcpy(type, "TRB"); break;
				case kShipSystemShuttleWeapon: strcpy(type, "ShutW"); break;
				case kShipSystemFighterSystem: strcpy(type, "FighS"); break;
				case kShipSystemDroneRackA: strcpy(type, "DroA"); dpr = 4; break;
				case kShipSystemDroneRackB: strcpy(type, "DroB"); dpr = 6; break;
				case kShipSystemDroneRackC: strcpy(type, "DroC"); dpr = 4; break;
				case kShipSystemDroneRackD: strcpy(type, "DroD"); dpr = 4; break;
				case kShipSystemDroneRackE: strcpy(type, "DroE"); dpr = 4; break;
				case kShipSystemDroneRackF: strcpy(type, "DroF"); dpr = 4; break;
				case kShipSystemDroneRackG: strcpy(type, "DroG"); dpr = 4; break;
				case kShipSystemDroneRackH: strcpy(type, "DroH"); dpr = 12; break;		// a guess
				case kShipSystemDroneFighter1: strcpy(type, "DroF1"); break;
				case kShipSystemDroneFighter4: strcpy(type, "DroF4"); break;
				case kShipSystemDroneRackMIRV: strcpy(type, "DroM"); dpr = 6; break;
				case kShipSystemOptional: strcpy(type, "Opt"); break;
				case kShipSystemOptionalW: strcpy(type, "OptW"); break;
				case kShipSystemPhaser1: strcpy(type, "Ph1"); break;
				case kShipSystemPhaser2: strcpy(type, "Ph2"); break;
				case kShipSystemPhaser3: strcpy(type, "Ph3"); break;
				case kShipSystemPhaserG: strcpy(type, "PhG"); break;
				case kShipSystemPhaserG2: strcpy(type, "PhG2"); break;
				case kShipSystemPhaser4: strcpy(type, "Ph4"); break;
				case kShipSystemPhaserX: strcpy(type, "PhX"); break;
				case kShipSystemADD6: strcpy(type, "ADD6"); break;
				case kShipSystemADD12: strcpy(type, "ADD12"); break;
				case kShipSystemADD30: strcpy(type, "ADD30"); break;
				default:  strcpy(type, "Unknown"); break;
			}

			sprintf(buf, "%dx%s\n", weaponCount, type);
			w_desc += buf;
		}
	}

	MessageBox(w_desc);
}
	
void CPickShip::OnFs1() 
{
	// TODO: Add your control notification handler code here
	if (m_fighter_count && m_fighter_bays)
		FighterSpecs(0);
}
