/*
 * PickShip.h
 *
 * Pick Ship Dialog.
 *
 * (C) 2001 MagnumMan-iCoP (James E. King, III)
 */

#if !defined(AFX_PICKSHIP_H__BC521CAC_6551_4BDB_A16B_BD9064696C54__INCLUDED_)
#define AFX_PICKSHIP_H__BC521CAC_6551_4BDB_A16B_BD9064696C54__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PickShip.h : header file
//

#include "Stdafx.h"
#include "SerializableShipDesc.h"

/////////////////////////////////////////////////////////////////////////////
// CPickShip dialog

class CPickShip : public CDialog
{
// Construction
public:
	CPickShip(CWnd* pParent = NULL);   // standard constructor

	typedef enum
	{
		kOrionPickMode,
		kBasePickMode
	} PickMode;

	PickMode		pickMode;
	inline void		setMode(PickMode m) { pickMode = m; }
	
// Dialog Data
	//{{AFX_DATA(CPickShip)
	enum { IDD = IDD_PICKSHIP };
	CString	m_bpv;
	CString	m_bpv_adj;
	CString	m_drone_size;
	CString	m_drone_speed;
	int		m_drone_count;
	int		m_marines;
	int		m_mines;
	int		m_repairs;
	CString	m_shield_1;
	CString	m_shield_4;
	CString	m_ship_code;
	CString	m_shuttles_max;
	int		m_shuttles;
	CString	m_weaponry_desc;
	CString	m_ship_class;
	int		m_fighter_bays;
	CString	m_fighter_cost;
	CString	m_fighter_type;
	CString	m_shield_2;
	CString	m_shield_3;
	CString	m_shield_5;
	CString	m_shield_6;
	int		m_fighter_count;
	//}}AFX_DATA

	int		m_fighter_bpv;

	SerializableShipDesc	GetSerializableShipDesc();
	void					Setup(SerializableShipDesc &);
	inline void				Setup(void) { Initialize(); };

	ShipList				sl;
	ShipList::iterator		sli;
	
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPickShip)
	public:
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CPickShip)
	afx_msg void OnDeltaposShipspin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDeltaposClassSpin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposMarinesspin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposMinesspin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposShuttlespin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposRepairsspin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposDronecountspin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposDronetypespin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposDronespeedspin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposFighternumspin1(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposFighterspin1(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposFighterspin2(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposFighterspin3(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposFighterspin4(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposFighternumspin2(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposFighternumspin3(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposFighternumspin4(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnFs1();
	afx_msg void OnFs2();
	afx_msg void OnFs3();
	afx_msg void OnFs4();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	afx_msg void OnDeltaposFighternumspinCOMMON(int num, NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposFighterspinCOMMON(int num, NMHDR* pNMHDR, LRESULT* pResult);
	void FighterSpecs(int num);

	void Initialize(void);
	void Recalculate(bool redraw = true);

	eClassTypes				cur_class;
	int						drones_per_reload;
	int						drone_reloads;
	int						fighter_base_bpv;	// always deduct from curr adjusted bpv
	RealShipListIter		fiter[4];
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PICKSHIP_H__BC521CAC_6551_4BDB_A16B_BD9064696C54__INCLUDED_)
