#include "stdafx.h"

#include "SectorAssaultData.h"
#include <Windows.h>

SectorAssaultData gSectorAssaultData;

SectorAssaultData::SectorAssaultData()
{
	memset(this, 0, sizeof(SectorAssaultData));
}

SectorAssaultData::~SectorAssaultData()
{
}

iTruth SectorAssaultData::FindSFCOPDirectory(std::string &location)
{
	HKEY	hKey;
	LONG	lval;
	DWORD	type;
	char	path[256];
	DWORD	siz = 256;

	lval = RegOpenKeyEx(HKEY_LOCAL_MACHINE,
						"Software\\Taldren\\Starfleet Command Orion Pirates",
						0,
						KEY_QUERY_VALUE,
						&hKey);

	if (lval != ERROR_SUCCESS)
		return false;

	lval = RegQueryValueEx(	hKey,
							"Directory",
							0,
							&type,
							(unsigned char *)path,
							&siz );

	RegCloseKey(hKey);

	if (lval != ERROR_SUCCESS)
		return kFalse;

	path[siz] = 0;
	if (path[siz - 1] != '\\')
		strcat(path, "\\");

	location = path;
	return kTrue;
}

iTruth SectorAssaultData::FindScriptsDirectory(std::string &location)
{
	iTruth t = FindSFCOPDirectory(location);
	if (t == kTrue)
		location.append("Assets\\Scripts\\");

	return t;
}

iTruth	SectorAssaultData::Load(void)
{
	char buf[64];
	std::string	scriptsINI;
	if (!FindScriptsDirectory(scriptsINI))
		return kFalse;
	scriptsINI += "scripts.ini";

	DWORD	rv = GetPrivateProfileString(
					"Mul_HumanSectorAssault", "DefSats",
					"", buf, 64,
					scriptsINI.c_str());

	if (rv)
		fNumDefSats = atoi(buf);
	else
		fNumDefSats = 0;

	rv = GetPrivateProfileString(
					"Mul_HumanSectorAssault", "FRDs",
					"", buf, 64,
					scriptsINI.c_str());

	if (rv)
		fNumFRDs = atoi(buf);
	else
		fNumFRDs = 0;				

	rv = GetPrivateProfileString(
					"Mul_HumanSectorAssault", "PlanetType",
					"", buf, 64,
					scriptsINI.c_str());

	if (rv)
		fPlanetType = atoi(buf);
	else
		fPlanetType = 0;	

	rv = GetPrivateProfileString(
					"Mul_HumanSectorAssault", "BaseDamage",
					"", buf, 64,
					scriptsINI.c_str());

	if (rv)
		fPercentBaseDamage = atoi(buf);
	else
		fPercentBaseDamage = 0;	

	rv = GetPrivateProfileString(
					"Mul_HumanSectorAssault", "PlanetDamage",
					"", buf, 64,
					scriptsINI.c_str());

	if (rv)
		fPercentPlanetDamage = atoi(buf);
	else
		fPercentPlanetDamage = 0;	

	return kTrue;
}

iTruth SectorAssaultData::Save(void)
{
	char buf[64];

	std::string	scriptsINI;
	if (!FindScriptsDirectory(scriptsINI))
		return kFalse;
	scriptsINI += "scripts.ini";

	sprintf(buf, "%d", fNumDefSats);
	if (!WritePrivateProfileString("Mul_HumanSectorAssault", "DefSats",
								   buf, scriptsINI.c_str()))
		return kFalse;
	
	sprintf(buf, "%d", fNumFRDs);
	if (!WritePrivateProfileString("Mul_HumanSectorAssault", "FRDs",
								   buf, scriptsINI.c_str()))
		return kFalse;
	
	sprintf(buf, "%d", fPlanetType);
	if (!WritePrivateProfileString("Mul_HumanSectorAssault", "PlanetType",
								   buf, scriptsINI.c_str()))
		return kFalse;
	
	sprintf(buf, "%d", fPercentBaseDamage);
	if (!WritePrivateProfileString("Mul_HumanSectorAssault", "BaseDamage",
								   buf, scriptsINI.c_str()))
		return kFalse;
	
	sprintf(buf, "%d", fPercentPlanetDamage);
	if (!WritePrivateProfileString("Mul_HumanSectorAssault", "PlanetDamage",
								   buf, scriptsINI.c_str()))
		return kFalse;
	
	return kTrue;
}

int32u	SectorAssaultData::mGetDefSats(void)  { return fNumDefSats; }
void    SectorAssaultData::mSetDefSats(int32u i) { fNumDefSats = i; }

int32u	SectorAssaultData::mGetFRDs(void)  { return fNumFRDs; }
void    SectorAssaultData::mSetFRDs(int32u i) { fNumFRDs = i; }

int32u	SectorAssaultData::mGetPlanetType(void)  { return fPlanetType; }
void    SectorAssaultData::mSetPlanetType(int32u i) { fPlanetType = i; }

int32u	SectorAssaultData::mGetPercentBaseDamage(void)  { return fPercentBaseDamage; }
void    SectorAssaultData::mSetPercentBaseDamage(int32u i) { fPercentBaseDamage = i; }

int32u	SectorAssaultData::mGetPercentPlanetDamage(void)  { return fPercentPlanetDamage; }
void    SectorAssaultData::mSetPercentPlanetDamage(int32u i) { fPercentPlanetDamage = i; }
