#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
#include "tclient.h"
#include "race.h"
#include "shipclasses.h"

class SectorAssaultData
{
private:
	
	//
	// Variables
	//

	int32u	fNumDefSats;
	int32u	fNumFRDs;
	int32u	fPlanetType;	// 0 = none, 1 = light, 2 = heavy
	int32u	fPercentBaseDamage;
	int32u	fPercentPlanetDamage;

public:

	SectorAssaultData();
	~SectorAssaultData();

	//
	// Used internally to find scripts.ini and sfc.ini
	//
	iTruth	FindScriptsDirectory(std::string &location);
	iTruth	FindSFCOPDirectory(std::string &location);

	//
	// Read/Write information from the scripts.ini
	//

	iTruth	Load(void);
	iTruth	Save(void);

	//
	// Accessors
	//

	int32u	mGetDefSats(void);
	void	mSetDefSats(int32u);

	int32u	mGetFRDs(void);
	void	mSetFRDs(int32u);

	int32u	mGetPlanetType(void);
	void	mSetPlanetType(int32u);

	int32u	mGetPercentBaseDamage(void);
	void	mSetPercentBaseDamage(int32u);

	int32u	mGetPercentPlanetDamage(void);
	void	mSetPercentPlanetDamage(int32u);
};

extern SectorAssaultData	gSectorAssaultData;