#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
#include "tclient.h"
#include "race.h"
#include "shipclasses.h"

class CoopData
{
private:
	
	//
	// Variables
	//
	float	fEnemyBPVRatio;
	int32u	fRaces;			// 1 << eRace as bitmap
	int32u	fShipClasses;	// 1 << eClassTypes as bitmap
	int32u  fAIIntel;		// Stored in sfc.ini [UI] UIType (Admiral=2 Captain=0)

	//
	// Used internally to find scripts.ini and sfc.ini
	//
	iTruth	FindScriptsDirectory(std::string &location);
	iTruth	FindSFCOPDirectory(std::string &location);

public:

	CoopData();
	~CoopData();

	//
	// Read/Write information from the scripts.ini
	//

	iTruth	Load(void);
	iTruth	Save(void);

	//
	// Accessors
	//

	float	mGetEnemyBPVRatio(void);
	void	mSetEnemyBPVRatio(float);

	void	mResetRaceSelections(void);
	iTruth	mIsRaceRandom(void);
	iTruth	mIsRaceSelected(eRace);
	void	mSetRaceSelected(eRace);

	void	mResetShipClassSelections(void);
	iTruth	mIsShipClassSelected(eClassTypes);
	void	mSetShipClassSelected(eClassTypes);

	int32u	mGetRawRaceSelected(void);
	int32u	mGetRawShipClassSelected(void);

	int32u	mGetAIIntel(void);
	void	mSetAIIntel(int32u);
};

extern CoopData	gCoopData;