/********************************************************************************************************\

	File Name:	EnemyTeamBaseState.cpp
	Descript:	<DESCRIPTION>

\********************************************************************************************************/

#include "EnemyTeam.h"
#include "EnemyTeamBaseState.h"
#include "worldconditions.h"
#include "CoopCustomizer/CoopData.h"

/*

	HELPER NOTE:	There are so many things that can be done here depending upon which mission you are
					coding.  So rather than list out possible bodies for each of the events below, the
					signatures have been given to save time cutting and pasting.

*/
void tEnemyTeamBaseState::mBeginState()
{
	if (fChildActor->mGetTeam() == kTeam7)		// show settings
	{
		mSetTimedInterval(kTimerSecondsSet, eStartupMsg, 5.0f);		// startup msg
	//	mSetTimedInterval(kTimerSecondsSet, eCreateEnemy, 15.0f);	// co-op enemy
	}		
}
void tEnemyTeamBaseState::mEndState()
{}

void tEnemyTeamBaseState::mOnDeath( tShipInfo* ship )
{
	if ( !ship )
		return;

//	fMissionInfo->mDebugMessage("tEnemyTeamBaseState::mOnDeath");
	mSetTimedInterval(kTimerSecondsSet, 1, 1.0f);
}
void tEnemyTeamBaseState::mOnCapture( tShipInfo* ship )
{
	if ( !ship )
		return;

//	fMissionInfo->mDebugMessage("tEnemyTeamBaseState::mOnCapture");
	mSetTimedInterval(kTimerSecondsSet, 1, 1.0f);
}
void tEnemyTeamBaseState::mOnDisengaged( tShipInfo* ship )
{}
void tEnemyTeamBaseState::mAtDistance( tShipInfo* ship )
{}
void tEnemyTeamBaseState::mAtDestination( tShipInfo* ship )
{}
void tEnemyTeamBaseState::mOnCommButtonPress( tShipInfo* ship, int32 buttonID, tShipInfo* targetShip )
{}
void tEnemyTeamBaseState::mOnDamage( tShipInfo* damagedShip, tShipInfo* hostileShip, eDamageToShip damageType )
{}
void tEnemyTeamBaseState::mOnDeepScan( tShipInfo* ship, iTruth deepScanOn )
{}
void tEnemyTeamBaseState::mOnAlertStatusChange( tShipInfo* ship, eAlertLevels alertStatus )
{}
void tEnemyTeamBaseState::mOnProbeLaunch( tShipInfo* ship )
{}
void tEnemyTeamBaseState::mOnBeginOrbit( tShipInfo* ship )
{}
void tEnemyTeamBaseState::mOnEndOrbit( tShipInfo* ship )
{}
void tEnemyTeamBaseState::mOnBeginTractor( tShipInfo* tractorTarget, tShipInfo* tractoringShip )
{}
void tEnemyTeamBaseState::mOnEndTractor( tShipInfo* tractorTarget, tShipInfo* tractoringShip )
{}
void tEnemyTeamBaseState::mOnFlashingButtonPressed()
{}
void tEnemyTeamBaseState::mOnTransportedItem( tShipInfo* shipTo, tShipInfo* shipFrom, eScriptTransportItems item )
{}
void tEnemyTeamBaseState::mOnChangingShip( tShipInfo* ship )
{}
void tEnemyTeamBaseState::mOnSpecialTransport( tShipInfo* ship )
{}
void tEnemyTeamBaseState::mOnShipSystemUpdate( tShipInfo* ship, eShipUpdateType type, eSystemHardPoint system, int32 value )
{}
void tEnemyTeamBaseState::mOnShipSystemUpdate( tShipInfo* ship, eShipUpdateType type, eSystemHardPoint system, float percent )
{}
void tEnemyTeamBaseState::mOnShipStoresUpdate(	tShipInfo* ship, eShipUpdateType type,
											eAccessShipStores_ItemTypes item, eAccessShipStores_SubTypes subItem, int32 value )
{}
void tEnemyTeamBaseState::mOnShipStoresUpdate(	tShipInfo* ship, eShipUpdateType type,
											eAccessShipStores_ItemTypes item, eScriptTransportItems subItem, int32 value )
{}

void tEnemyTeamBaseState::mOnPlayerLeaving( int32 playerNumber, eTeamID TeamID )
{}
void tEnemyTeamBaseState::mOnHostChanged()
{
	gWC.mCheckForGameEnd();
}
static char * sCvIntel(int32u i)
{
	switch (i)
	{
		case 0: return "Captain";
		case 1: return "Commodore";
		case 2: return "Admiral";
		default:return "Unknown Value";
	}
}
void tEnemyTeamBaseState::mOnTimedInterval( int32 timerID )
{
	if (timerID == eStartupMsg)
	{
		char buf[512];
		sprintf(buf, "MagnumMan's Co-op Ace for SFC:OP\n(C) 2001 James E. King, III\n\nDifficulty Multiplier: %1.2f (%s Level)\nEnemy Race: %s", gCoopData.mGetEnemyBPVRatio(),
			sCvIntel(gCoopData.mGetAIIntel()), (gCoopData.mIsRaceRandom() ? "Single Random Race" : "Host-Selected Races"));

		for (int k = (int)kTeam1; k <= (int)kTeam6; k++)
			fMissionInfo->mDisplayMessage((eTeamID)k, buf);

		mSetTimedInterval(kTimerSecondsSet, eCheckEnd, 5.0f);
	}
/*	else if (timerID == eCreateEnemy)
	{
		for (int k = (int)kTeam1; k <= (int)kTeam6; k++)
			fMissionInfo->mDisplayMessage((eTeamID)k, "Creating Enemy Fleet...");

		((tEnemyTeam *)fChildActor)->mCreateCoopEnemy();
		mSetTimedInterval(kTimerSecondsSet, eCheckEnd, 5.0f);
	} */
	else if (timerID == eCheckEnd)
	{
		gWC.mCheckForGameEnd();
	}
}
void tEnemyTeamBaseState::mOnStateChange( tActor* actor, tState* stateID, eStateEvent eventType )
{}
void tEnemyTeamBaseState::mOnCommStateChange( tActor* actor, int32 state, eStateEvent eventType )
{}

