/********************************************************************************************************\

	File Name:	HumanTeam.cpp
	Descript:	<DESCRIPTION>

\********************************************************************************************************/

#include "tclient.h"
#include "CommonDefs.h"
#include "HumanTeam.h"
#include "HumanTeamBaseVictory.h"
#include "MissionText.h"
#include "ShipScriptDescription.h"
#include "Mul_CoopAce.h"

tClassAllocator<tHumanTeam> gHumanTeamAllocator;

void tHumanTeam::mSetupVictoryCondition()
{
	fVictoryCondition = new tHumanTeamBaseVictory( this );
	gEventMgr.mRegisterActor( fVictoryCondition );
}

void tHumanTeam::mSetupDebriefingList( eVictoryLevels victoryLevel )
{
//	fMissionInfo->mDebugMessage("tHumanTeam::mSetupDebriefingList");
	
	switch ( victoryLevel )
	{
	case kAstoundingVictory:
	case kVictory:
		fMissionInfo->mAddToDebriefingList( fTeam, kWinner_msg );		break;
	case kDevastatingDefeat:
	case kDefeat:
		fMissionInfo->mAddToDebriefingList( fTeam, kLoser_msg );		break;
	case kUnknownVictoryLevel:
		fMissionInfo->mAddToDebriefingList( fTeam, kLeftEarly_msg );	break;
	case kDraw:
	default:
		fMissionInfo->mAddToDebriefingList( fTeam, kDefault_msg );		break;
	}
}

void tHumanTeam::mSetupState()
{
}

void tHumanTeam::mSetupCommState()
{}

void tHumanTeam::mCreateShipsForTeam()
{}

void tHumanTeam::mTeamSetupComplete()
{
	tTeamInfo::mTeamSetupComplete();
}

void tHumanTeam::mCreateNewShip( const tShipScriptDescription& shipScriptDescription )
{
	pscnl.push_back(shipScriptDescription.fClassName);
	
	mCreateShip( typeid( tShipInfo ), 
				 shipScriptDescription.fClassName.c_str(), 
				 kStartPosition_G + shipScriptDescription.fTeamID,
				 kNoMetaShipID,
				 -1, 0, 0, -1, -1,
				 shipScriptDescription.fCustomName.c_str(),
				 static_cast< eShipOptions >( kDefaultShipOptions | kCanBeCarrier ) );
}



