/********************************************************************************************************\

	File Name:	CommonPlayerShipBaseState.cpp
	Descript:	<DESCRIPTION>

\********************************************************************************************************/

#include "CommonPlayerShipBaseState.h"
#include "Mul_HumanSectorAssault.h"
#include "SectorAssaultData.h"

/*

	HELPER NOTE:	There are so many things that can be done here depending upon which mission you are
					coding.  So rather than list out possible bodies for each of the events below, the
					signatures have been given to save time cutting and pasting.

*/
void tCommonPlayerShipBaseState::mBeginState()
{
	mSetTimedInterval(kTimerSecondsSet, 1, 2.5f);	
}
void tCommonPlayerShipBaseState::mEndState()
{}

void tCommonPlayerShipBaseState::mOnDeath( tShipInfo* ship )
{}
void tCommonPlayerShipBaseState::mOnCapture( tShipInfo* ship )
{}
void tCommonPlayerShipBaseState::mOnDisengaged( tShipInfo* ship )
{}
void tCommonPlayerShipBaseState::mAtDistance( tShipInfo* ship )
{}
void tCommonPlayerShipBaseState::mAtDestination( tShipInfo* ship )
{}
void tCommonPlayerShipBaseState::mOnCommButtonPress( tShipInfo* ship, int32 buttonID, tShipInfo* targetShip )
{}
void tCommonPlayerShipBaseState::mOnDamage( tShipInfo* damagedShip, tShipInfo* hostileShip, eDamageToShip damageType )
{}
void tCommonPlayerShipBaseState::mOnDeepScan( tShipInfo* ship, iTruth deepScanOn )
{}
void tCommonPlayerShipBaseState::mOnAlertStatusChange( tShipInfo* ship, eAlertLevels alertStatus )
{}
void tCommonPlayerShipBaseState::mOnProbeLaunch( tShipInfo* ship )
{}
void tCommonPlayerShipBaseState::mOnBeginOrbit( tShipInfo* ship )
{}
void tCommonPlayerShipBaseState::mOnEndOrbit( tShipInfo* ship )
{}
void tCommonPlayerShipBaseState::mOnBeginTractor( tShipInfo* tractorTarget, tShipInfo* tractoringShip )
{}
void tCommonPlayerShipBaseState::mOnEndTractor( tShipInfo* tractorTarget, tShipInfo* tractoringShip )
{}
void tCommonPlayerShipBaseState::mOnFlashingButtonPressed()
{}
void tCommonPlayerShipBaseState::mOnTransportedItem( tShipInfo* shipTo, tShipInfo* shipFrom, eScriptTransportItems item )
{}
void tCommonPlayerShipBaseState::mOnChangingShip( tShipInfo* ship )
{}
void tCommonPlayerShipBaseState::mOnSpecialTransport( tShipInfo* ship )
{}
void tCommonPlayerShipBaseState::mOnShipSystemUpdate( tShipInfo* ship, eShipUpdateType type, eSystemHardPoint system, int32 value )
{}
void tCommonPlayerShipBaseState::mOnShipSystemUpdate( tShipInfo* ship, eShipUpdateType type, eSystemHardPoint system, float percent )
{}
void tCommonPlayerShipBaseState::mOnShipStoresUpdate(	tShipInfo* ship, eShipUpdateType type,
											eAccessShipStores_ItemTypes item, eAccessShipStores_SubTypes subItem, int32 value )
{}
void tCommonPlayerShipBaseState::mOnShipStoresUpdate(	tShipInfo* ship, eShipUpdateType type,
											eAccessShipStores_ItemTypes item, eScriptTransportItems subItem, int32 value )
{}

void tCommonPlayerShipBaseState::mOnPlayerLeaving( int32 playerNumber, eTeamID TeamID )
{}
void tCommonPlayerShipBaseState::mOnHostChanged()
{}
void tCommonPlayerShipBaseState::mOnTimedInterval( int32 timerID )
{
	SectorAssaultData	sad;

	if (timerID == 1)
	{
		char buf[128];
		int	 fDamage = 0;

		sprintf(buf, "CommonPlayerShip Startup Damage Routine for ship %s", fChildActor->mGetCustomName());
		fMissionInfo->mDebugMessage(buf);

		std::string	scriptsINI;
		if (!sad.FindScriptsDirectory(scriptsINI))
			return;
		scriptsINI += "scripts.ini";

		DWORD	rv = GetPrivateProfileString(
						"StartupDamagePct", fChildActor->mGetCustomName(),
						"", buf, 64,
						scriptsINI.c_str());

		if (rv)
			fDamage = atoi(buf);
		else
			fDamage = 0;

		if (!fDamage)
		{
			sprintf(buf, "%s (%s) has received no startup damage.", fChildActor->mGetClassName(), fChildActor->mGetCustomName(), fDamage);
			for (int team = (int)kTeam1; team <= (int)kTeam6; team++)
				gScriptInterface.mMission()->mDisplayMessage(static_cast<eTeamID>(team), buf);
		}
		else
		{
			float sfcDmgPct = (float)fDamage * 0.01f;
			fChildActor->mDamageRandomInternals(sfcDmgPct);

			sprintf(buf, "%s (%s) has received %d%% startup damage.", fChildActor->mGetClassName(), fChildActor->mGetCustomName(), fDamage);
			for (int team = (int)kTeam1; team <= (int)kTeam6; team++)
				gScriptInterface.mMission()->mDisplayMessage(static_cast<eTeamID>(team), buf);
		}
	}
}
void tCommonPlayerShipBaseState::mOnStateChange( tActor* actor, tState* stateID, eStateEvent eventType )
{}
void tCommonPlayerShipBaseState::mOnCommStateChange( tActor* actor, int32 state, eStateEvent eventType )
{}

