/********************************************************************************************************\

	Mission:	Mul_HumanSectorAssault
	Script:		"Mul_HumanSectorAssault"
	Descript:	<DESCRIPTION>

	Created by:		<NAME>			mm/dd/yy
	Last Updated:	<INITIALS>		mm/dd/yy
					<LOG>


\********************************************************************************************************/

#include "MissionText.h"
#include "MissionMaps.h"
#include "Team1.h"
#include "Team2.h"
#include "Team3.h"
#include "Team4.h"
#include "Team5.h"
#include "Team6.h"
#include "Team7.h"
#include "Team8.h"
#include "Mul_HumanSectorAssault.h"
#include "VictoryCondition.h"

#include "FleetPickContainer.h"

FleetPickContainer	fpc;

DEFINE_SCRIPT_CLASS( tMul_HumanSectorAssault );

tMul_HumanSectorAssault::tMul_HumanSectorAssault()
{
	srand(GetTickCount());
}

void tMul_HumanSectorAssault::mScriptSpecs( tMissionSpec* Specs )
{
	Specs->fMissionTitle = Messages[kMissionTitle_msg];
	Specs->fMissionDescription = Messages[kDescription_msg];
	Specs->fHelpTags = Messages[kHelpTags_msg];
	Specs->fMissionType = kMultiplayerMission;
	Specs->fPlayerRace = kSpecAnyRace;
	Specs->fNumShips = kMissSpecAllShips;
	Specs->fMenuStates = kEnableSupplyDock | kDisableTagC | kDisableTagD | kDisableTagE | kDisableTagF;
	Specs->fBandwidthPart = static_cast< eBandwidthPart >( k1Band | k5Client );

	const tTeamSpec& team1 = mCreateTeamSpec(	"Team 1",
												kTeam1,
												kMaxChance,
												kTrue,
												kPlayableTeam,
												kMinChance,
												kSpecPlayableRace,
												kAnyRace,
												typeid( tTeam1 ));

	const tTeamSpec& team2 = mCreateTeamSpec(	"Team 2",
												kTeam2,
												kMaxChance,
												kTrue,
												kPlayableTeam,
												kMinChance,
												kSpecPlayableRace,
												kAnyRace,
												typeid( tTeam2 ));

	const tTeamSpec& team3 = mCreateTeamSpec(	"Team 3",
												kTeam3,
												kMaxChance,
												kTrue,
												kPlayableTeam,
												kMinChance,
												kSpecPlayableRace,
												kAnyRace,
												typeid( tTeam3 ));

	const tTeamSpec& team4 = mCreateTeamSpec(	"Team 4",
												kTeam4,
												kMaxChance,
												kTrue,
												kPlayableTeam,
												kMinChance,
												kSpecPlayableRace,
												kAnyRace,
												typeid( tTeam4 ));

	const tTeamSpec& team5 = mCreateTeamSpec(	"Team 5",
												kTeam5,
												kMaxChance,
												kTrue,
												kPlayableTeam,
												kMinChance,
												kSpecPlayableRace,
												kAnyRace,
												typeid( tTeam5 ));

	const tTeamSpec& team6 = mCreateTeamSpec(	"Team 6",
												kTeam6,
												kMaxChance,
												kTrue,
												kPlayableTeam,
												kMinChance,
												kSpecPlayableRace,
												kAnyRace,
												typeid( tTeam6 ));

	const tTeamSpec& team7 = mCreateTeamSpec(	"Team 7",
												kTeam7,
												kMaxChance,
												kTrue,
												kNPCTeam,
												kMinChance,
												kSpecPlayableRace,
												kAnyRace,
												typeid( tTeam7 ),
												kTagA);

	const tTeamSpec& team8 = mCreateTeamSpec(	"Team 8",
												kTeam8,
												kMaxChance,
												kTrue,
												kNPCTeam,
												kMinChance,
												kSpecPlayableRace,
												kAnyRace,
												typeid( tTeam8 ),
												kTagA);

	Specs->mSetupTeam( team1 );
	Specs->mSetupTeam( team2 );
	Specs->mSetupTeam( team3 );
	Specs->mSetupTeam( team4 );
	Specs->mSetupTeam( team5 );
	Specs->mSetupTeam( team6 );
	Specs->mSetupTeam( team7 );
	Specs->mSetupTeam( team8 );
}

int32 tMul_HumanSectorAssault::mInitializeStart( tDynaverseScriptInfo& info )
{
	return 1;
}

void tMul_HumanSectorAssault::mCreateExternalShips( int32 Mode )
{}

int32 tMul_HumanSectorAssault::mInitializeFinished( void )
{
	return kBriefing_msg;
}

void tMul_HumanSectorAssault::mNewInternalShip( tShipInfo* Ship )
{}

void tMul_HumanSectorAssault::mStartMission()
{
	tScript::mStartMission();

	const int kRelationsCount = 2;
	int32 tagList[kRelationsCount] =
	{
		kTagA,
		kTagB
	};

	std::string relationships[kRelationsCount][kRelationsCount] =
	{
			//		 A     B   
		{	/*A   */ "AI", "WD"		},
		{	/*B   */ "WD", "AI"		}
	};

	fMissionInfo->mSetTagRelations( tagList, ( std::string* )relationships, kRelationsCount );
}

void tMul_HumanSectorAssault::mNewTeam( const tTeamScriptDescription& teamScriptDescription )
{
/*	FILE *fp = fopen("C:\\SATEAM.TXT", "a+");

	fprintf(fp, "mNewTeam\n");
	fprintf(fp, "\tfTeam = %d\n", teamScriptDescription.fTeam);
	fprintf(fp, "\tfRace = %d\n", teamScriptDescription.fRace);
	fprintf(fp, "\tfHumanControlled = %d\n", teamScriptDescription.fHumanControlled);
	fprintf(fp, "\tfTeamActorID = %d\n", teamScriptDescription.fTeamActorID);
	fprintf(fp, "\tfTeamTag = %d\n", teamScriptDescription.fTeamTag);
	fprintf(fp, "\n");
	fclose(fp); */

	tScript::mNewTeam( teamScriptDescription );
}

void tMul_HumanSectorAssault::mASCIIOverrides( tMapOverrides* Map )
{
	tScript::mASCIIOverrides( Map );

	Map->fTacticalMapIcon['G'] = kObjectPlayerShip;
	Map->fTacticalMapIcon['H'] = kObjectEnemyShip;
}
