/********************************************************************************************************\

	File Name:	Team1StarbaseState.cpp
	Descript:	<DESCRIPTION>

\********************************************************************************************************/

#include "Team1StarbaseState.h"
#include "Mul_HumanSectorAssault.h"
#include "SectorAssaultData.h"

/*

	HELPER NOTE:	There are so many things that can be done here depending upon which mission you are
					coding.  So rather than list out possible bodies for each of the events below, the
					signatures have been given to save time cutting and pasting.

*/
void tTeam1StarbaseState::mBeginState()
{
	mSetTimedInterval(kTimerSecondsSet, 1, 1.0f);	
}
void tTeam1StarbaseState::mEndState()
{}

void tTeam1StarbaseState::mOnDeath( tShipInfo* ship )
{}
void tTeam1StarbaseState::mOnCapture( tShipInfo* ship )
{}
void tTeam1StarbaseState::mOnDisengaged( tShipInfo* ship )
{}
void tTeam1StarbaseState::mAtDistance( tShipInfo* ship )
{}
void tTeam1StarbaseState::mAtDestination( tShipInfo* ship )
{}
void tTeam1StarbaseState::mOnCommButtonPress( tShipInfo* ship, int32 buttonID, tShipInfo* targetShip )
{}
void tTeam1StarbaseState::mOnDamage( tShipInfo* damagedShip, tShipInfo* hostileShip, eDamageToShip damageType )
{}
void tTeam1StarbaseState::mOnDeepScan( tShipInfo* ship, iTruth deepScanOn )
{}
void tTeam1StarbaseState::mOnAlertStatusChange( tShipInfo* ship, eAlertLevels alertStatus )
{}
void tTeam1StarbaseState::mOnProbeLaunch( tShipInfo* ship )
{}
void tTeam1StarbaseState::mOnBeginOrbit( tShipInfo* ship )
{}
void tTeam1StarbaseState::mOnEndOrbit( tShipInfo* ship )
{}
void tTeam1StarbaseState::mOnBeginTractor( tShipInfo* tractorTarget, tShipInfo* tractoringShip )
{}
void tTeam1StarbaseState::mOnEndTractor( tShipInfo* tractorTarget, tShipInfo* tractoringShip )
{}
void tTeam1StarbaseState::mOnFlashingButtonPressed()
{}
void tTeam1StarbaseState::mOnTransportedItem( tShipInfo* shipTo, tShipInfo* shipFrom, eScriptTransportItems item )
{}
void tTeam1StarbaseState::mOnChangingShip( tShipInfo* ship )
{}
void tTeam1StarbaseState::mOnSpecialTransport( tShipInfo* ship )
{}
void tTeam1StarbaseState::mOnShipSystemUpdate( tShipInfo* ship, eShipUpdateType type, eSystemHardPoint system, int32 value )
{}
void tTeam1StarbaseState::mOnShipSystemUpdate( tShipInfo* ship, eShipUpdateType type, eSystemHardPoint system, float percent )
{}
void tTeam1StarbaseState::mOnShipStoresUpdate(	tShipInfo* ship, eShipUpdateType type,
											eAccessShipStores_ItemTypes item, eAccessShipStores_SubTypes subItem, int32 value )
{}
void tTeam1StarbaseState::mOnShipStoresUpdate(	tShipInfo* ship, eShipUpdateType type,
											eAccessShipStores_ItemTypes item, eScriptTransportItems subItem, int32 value )
{}

void tTeam1StarbaseState::mOnPlayerLeaving( int32 playerNumber, eTeamID TeamID )
{}
void tTeam1StarbaseState::mOnHostChanged()
{}
void tTeam1StarbaseState::mOnTimedInterval( int32 timerID )
{
	if (timerID == 1)
	{
		SerializableShipDesc ssd = fpc.getSSD(1);

		int type1S = -1;
		int type1M = -1;
		int type1F = -1;
		int type4S = -1;
		int type4M = -1;
		int type4F = -1;

		switch (ssd.drone_size)
		{
			case 1:
				
				switch (ssd.drone_speed)
				{
					case 1: type1S = ssd.drone_count; break;
					case 2: type1M = ssd.drone_count; break;
					case 3: type1F = ssd.drone_count; break;
				}
				break;

			case 4:

				switch (ssd.drone_speed)
				{
					case 1: type4S = ssd.drone_count; break;
					case 2: type4M = ssd.drone_count; break;
					case 3: type4F = ssd.drone_count; break;
				}
				break;
		}

	//	fMissionInfo->mDebugMessage("Setting base loadout.");
		
		fChildActor->mSetShipLoadout
		(
			ssd.marines,
			ssd.repairs,
			ssd.mines,
			ssd.shuttles,
			ssd.fighter_bays,
			ssd.fighter_count,
			ssd.fighter_type,
			type1S, type1M, type1F,
			type4S, type4M, type4F
		);

		mSetTimedInterval(kTimerSecondsSet, 2, 1.0f);		
	}
	else if (timerID == 2)
	{
		char buf[128];
		SectorAssaultData	sad;
		sad.Load();

		int percentRaw = sad.mGetPercentBaseDamage();
		if (percentRaw < 0)
			percentRaw = 0;
		if (percentRaw > 100)
			percentRaw = 100;

		if (percentRaw)
		{
			float sfcStylePct = ((float)percentRaw * 0.01f);
			fChildActor->mDamageRandomInternals(sfcStylePct);
			// casting to a float makes it a percentage

			sprintf(buf, "The base has received %d%% startup damage.", percentRaw);
			for (int team = (int)kTeam1; team <= (int)kTeam6; team++)
				gScriptInterface.mMission()->mDisplayMessage(static_cast<eTeamID>(team), buf);
		}
		else
		{
			sprintf(buf, "The base has received no startup damage.");
			for (int team = (int)kTeam1; team <= (int)kTeam6; team++)
				gScriptInterface.mMission()->mDisplayMessage(static_cast<eTeamID>(team), buf);
		}
	}
}
void tTeam1StarbaseState::mOnStateChange( tActor* actor, tState* stateID, eStateEvent eventType )
{}
void tTeam1StarbaseState::mOnCommStateChange( tActor* actor, int32 state, eStateEvent eventType )
{}

