/********************************************************************************************************\

	File Name:	Team5BaseState.h
	Descript:	<DESCRIPTION>

\********************************************************************************************************/

#if !defined( Team5BaseState_h )
#define Team5BaseState_h

#include "ChildActorState.h"
#include "Team5.h"


class tTeam5BaseState : public tChildActorState<tTeam5>
{
public:

	//
	//	Serialization events
	//
	virtual void mBeginState();
	virtual void mEndState();

	//
	//	Ship events
	//
	virtual void mOnDeath( tShipInfo* ship );
	virtual void mOnCapture( tShipInfo* ship );
	virtual void mOnDisengaged( tShipInfo* ship );
	virtual void mAtDistance( tShipInfo* ship );
	virtual void mAtDestination( tShipInfo* ship );
	virtual void mOnCommButtonPress( tShipInfo* ship, int32 buttonID, tShipInfo* targetShip );
	virtual void mOnDamage( tShipInfo* damagedShip, tShipInfo* hostileShip, eDamageToShip damageType );
	virtual void mOnDeepScan( tShipInfo* ship, iTruth deepScanOn );
	virtual void mOnAlertStatusChange( tShipInfo* ship, eAlertLevels alertStatus );
	virtual void mOnProbeLaunch( tShipInfo* ship );
	virtual void mOnBeginOrbit( tShipInfo* ship );
	virtual void mOnEndOrbit( tShipInfo* ship );
	virtual void mOnBeginTractor( tShipInfo* tractorTarget, tShipInfo* tractoringShip );
	virtual void mOnEndTractor( tShipInfo* tractorTarget, tShipInfo* tractoringShip );
	virtual void mOnFlashingButtonPressed();
	virtual void mOnTransportedItem( tShipInfo* shipTo, tShipInfo* shipFrom, eScriptTransportItems item );
	virtual void mOnChangingShip( tShipInfo* ship );
	virtual void mOnSpecialTransport( tShipInfo* ship );
	virtual void mOnShipSystemUpdate( tShipInfo* ship, eShipUpdateType type, eSystemHardPoint system, int32 value );
	virtual void mOnShipSystemUpdate( tShipInfo* ship, eShipUpdateType type, eSystemHardPoint system, float percent );
	virtual void mOnShipStoresUpdate( tShipInfo* ship, eShipUpdateType type, 
									  eAccessShipStores_ItemTypes item, eAccessShipStores_SubTypes subItem, int32 value );
	virtual void mOnShipStoresUpdate( tShipInfo* ship, eShipUpdateType type,
									  eAccessShipStores_ItemTypes item, eScriptTransportItems subItem, int32 value );
	
	//
	//	System events
	//
	virtual void mOnPlayerLeaving( int playerNumber );
	virtual void mOnHostChanged();
	virtual void mOnTimedInterval( int32 timerID );
	virtual void mOnStateChange( tActor* actor, tState* stateID, eStateEvent eventType );
	virtual void mOnCommStateChange( tActor* actor, int32 state, int32 buttonID, eStateEvent eventType );
};

#endif






