/********************************************************************************************************\

	File Name:	Team7.cpp
	Descript:	<DESCRIPTION>

\********************************************************************************************************/

#include "tclient.h"
#include "CommonDefs.h"
#include "Team7.h"
#include "Team7BaseState.h"
#include "SectorAssaultData.h"
#include "Team7Planet.h"

extern char gBaseRace;

tClassAllocator<tTeam7> gTeam7Allocator;

/*

	HELPER NOTE:	If you create any new states on the team level, you must register them here first.

*/
void tTeam7::mSetupState()
{
	mRegisterState( new tTeam7BaseState() );
	mGotoState( typeid( tTeam7BaseState ) );
}

void tTeam7::mSetupCommState()
{}

typedef struct
{
	int32	offGX;		// Offset from G starting point X coord
	int32	offGY;		// Offset from G starting point Y coord
} Offset;

#define MAXFRDS	3

Offset frdOffsets[MAXFRDS+1][MAXFRDS+1] =
{
	{ { 0,  0  }, { 0,  0  }, { 0,  0  }, { 0,  0  } },		// 0 FRDs
	{ { -2, 0  }, { 0,  0  }, { 0,  0  }, { 0,  0  } },		// 1 FRDs
	{ { -2, -1 }, { -2, 1  }, { 0,  0  }, { 0,  0  } },		// 2 FRDs
	{ { -2, -2 }, { -2, 0  }, { -2, 2  }, { 0,  0  } }		// 3 FRDs
};

void tTeam7::mCreateShipsForTeam()
{
	char shipName[16];

	SectorAssaultData	sad;
	int					i;

	sad.Load();

	int32	gridX, origGridX;
	int32	gridY, origGridY;
	fMissionInfo->mGetGridPosition('G', &origGridX, &origGridY);

	for (i = 0; i < sad.mGetFRDs(); i++)
	{
		char customName[32];

		gridX = origGridX + frdOffsets[sad.mGetFRDs()][i].offGX;
		gridY = origGridY + frdOffsets[sad.mGetFRDs()][i].offGY;

		sprintf(shipName, "%c-FRD", gBaseRace);
		sprintf(customName, "FRD-%d", i+1);

		mCreateShip( typeid( tShipInfo ),
				 shipName,
				 kStartPosition_Specified,
				 kNoMetaShipID,
				 700+i,
				 gridX, gridY, origGridX, origGridY,
				 customName, // shipScriptDescription.fCustomName.c_str(),
				 static_cast< eShipOptions >( kDefaultShipOptions | kCanBeCarrier ) );
	}

	i = sad.mGetPlanetType();
	if (i > 0)
	{
		int32	planetNum;
		
		for (;;)
		{
			planetNum = (rand() % 10) + 1;
			if (planetNum != 2 && planetNum != 6)		// Planet 2 is ringed planet (huge)
				break;									// same for 6
		}

		gridX = origGridX - 3;		// without FRDs we can put the planet at distance 30
		if (sad.mGetFRDs())
			gridX -= 2;				// however with the FRDs we need more space
		gridY = origGridY;

		if (i == 1)
			sprintf(shipName, "%c-PL%d", gBaseRace, planetNum);
		else
			sprintf(shipName, "%c-PLPh%d", gBaseRace, planetNum);

		mCreateShip( typeid( tTeam7Planet ),	// to implement startup damage
				 shipName,
				 kStartPosition_Specified,
				 kNoMetaShipID,
				 710,
				 gridX, gridY, origGridX, origGridY,
				 "The Planet", // shipScriptDescription.fCustomName.c_str(),
				 static_cast< eShipOptions >( kDefaultShipOptions | kCanBeCarrier ) );
	}
}

void tTeam7::mTeamSetupComplete()
{
	tTeamInfo::mTeamSetupComplete();
}


