/********************************************************************************************************\

	File Name:	Team7PlanetState.cpp
	Descript:	<DESCRIPTION>

\********************************************************************************************************/

#include "Team7PlanetState.h"
#include "Mul_HumanSectorAssault.h"
#include "SectorAssaultData.h"


/*

	HELPER NOTE:	There are so many things that can be done here depending upon which mission you are
					coding.  So rather than list out possible bodies for each of the events below, the
					signatures have been given to save time cutting and pasting.

*/
void tTeam7PlanetState::mBeginState()
{
	mSetTimedInterval(kTimerSecondsSet, 1, 1.5f);	
}
void tTeam7PlanetState::mEndState()
{}

void tTeam7PlanetState::mOnDeath( tShipInfo* ship )
{}
void tTeam7PlanetState::mOnCapture( tShipInfo* ship )
{}
void tTeam7PlanetState::mOnDisengaged( tShipInfo* ship )
{}
void tTeam7PlanetState::mAtDistance( tShipInfo* ship )
{}
void tTeam7PlanetState::mAtDestination( tShipInfo* ship )
{}
void tTeam7PlanetState::mOnCommButtonPress( tShipInfo* ship, int32 buttonID, tShipInfo* targetShip )
{}
void tTeam7PlanetState::mOnDamage( tShipInfo* damagedShip, tShipInfo* hostileShip, eDamageToShip damageType )
{}
void tTeam7PlanetState::mOnDeepScan( tShipInfo* ship, iTruth deepScanOn )
{}
void tTeam7PlanetState::mOnAlertStatusChange( tShipInfo* ship, eAlertLevels alertStatus )
{}
void tTeam7PlanetState::mOnProbeLaunch( tShipInfo* ship )
{}
void tTeam7PlanetState::mOnBeginOrbit( tShipInfo* ship )
{}
void tTeam7PlanetState::mOnEndOrbit( tShipInfo* ship )
{}
void tTeam7PlanetState::mOnBeginTractor( tShipInfo* tractorTarget, tShipInfo* tractoringShip )
{}
void tTeam7PlanetState::mOnEndTractor( tShipInfo* tractorTarget, tShipInfo* tractoringShip )
{}
void tTeam7PlanetState::mOnFlashingButtonPressed()
{}
void tTeam7PlanetState::mOnTransportedItem( tShipInfo* shipTo, tShipInfo* shipFrom, eScriptTransportItems item )
{}
void tTeam7PlanetState::mOnChangingShip( tShipInfo* ship )
{}
void tTeam7PlanetState::mOnSpecialTransport( tShipInfo* ship )
{}
void tTeam7PlanetState::mOnShipSystemUpdate( tShipInfo* ship, eShipUpdateType type, eSystemHardPoint system, int32 value )
{}
void tTeam7PlanetState::mOnShipSystemUpdate( tShipInfo* ship, eShipUpdateType type, eSystemHardPoint system, float percent )
{}
void tTeam7PlanetState::mOnShipStoresUpdate(	tShipInfo* ship, eShipUpdateType type,
											eAccessShipStores_ItemTypes item, eAccessShipStores_SubTypes subItem, int32 value )
{}
void tTeam7PlanetState::mOnShipStoresUpdate(	tShipInfo* ship, eShipUpdateType type,
											eAccessShipStores_ItemTypes item, eScriptTransportItems subItem, int32 value )
{}

void tTeam7PlanetState::mOnPlayerLeaving( int32 playerNumber, eTeamID TeamID )
{}
void tTeam7PlanetState::mOnHostChanged()
{}
void tTeam7PlanetState::mOnTimedInterval( int32 timerID )
{
	if (timerID == 1)
	{
		char buf[128];
		SectorAssaultData	sad;
		sad.Load();

		int percentRaw = sad.mGetPercentPlanetDamage();
		if (percentRaw < 0)
			percentRaw = 0;
		if (percentRaw > 100)
			percentRaw = 100;

		if (percentRaw)
		{
			float sfcStylePct = ((float)percentRaw * 0.01f);
			fChildActor->mDamageRandomInternals(sfcStylePct);
			// casting to a float makes it a percentage

			sprintf(buf, "The planet has received %d%% startup damage.", percentRaw);
			for (int team = (int)kTeam1; team <= (int)kTeam6; team++)
				gScriptInterface.mMission()->mDisplayMessage(static_cast<eTeamID>(team), buf);
		}
		else
		{
			sprintf(buf, "The planet has received no startup damage.");
			for (int team = (int)kTeam1; team <= (int)kTeam6; team++)
				gScriptInterface.mMission()->mDisplayMessage(static_cast<eTeamID>(team), buf);
		}
	}
}
void tTeam7PlanetState::mOnStateChange( tActor* actor, tState* stateID, eStateEvent eventType )
{}
void tTeam7PlanetState::mOnCommStateChange( tActor* actor, int32 state, eStateEvent eventType )
{}

