/********************************************************************************************************\

	File Name:	Team8.cpp
	Descript:	<DESCRIPTION>

\********************************************************************************************************/

#include "tclient.h"
#include "CommonDefs.h"
#include "Team8.h"
#include "Team8BaseState.h"
#include "SectorAssaultData.h"

extern char gBaseRace;

tClassAllocator<tTeam8> gTeam8Allocator;

void tTeam8::mSetupState()
{
	mRegisterState( new tTeam8BaseState() );
	mGotoState( typeid( tTeam8BaseState ) );
}

void tTeam8::mSetupCommState()
{}

typedef struct
{
	int32	offGX;		// Offset from G starting point X coord
	int32	offGY;		// Offset from G starting point Y coord
} Offset;

#define MAXDEFS 8

Offset defOffsets[MAXDEFS+1][MAXDEFS+1] =
{
	{	{ 0,  0  }, { 0,  0  }, { 0,  0  }, { 0,  0  },
		{ 0,  0  }, { 0,  0  }, { 0,  0  }, { 0,  0  }, { 0,  0  } },	// 0 DefSats
	{	{ 1,  0  }, { 0,  0  }, { 0,  0  }, { 0,  0  },
		{ 0,  0  }, { 0,  0  }, { 0,  0  }, { 0,  0  }, { 0,  0  } },	// 1 DefSats
	{	{ 0, -1  }, { 0,  1  }, { 0,  0  }, { 0,  0  },
		{ 0,  0  }, { 0,  0  }, { 0,  0  }, { 0,  0  }, { 0,  0  } },	// 2 DefSats
	{	{ 1, -1  }, { 1,  1  }, { -1, 0  }, { 0,  0  },
		{ 0,  0  }, { 0,  0  }, { 0,  0  }, { 0,  0  }, { 0,  0  } },	// 3 DefSats
	{	{ 1, -1  }, { 1,  1  }, { -1, -1 }, { -1, 1  },
		{ 0,  0  }, { 0,  0  }, { 0,  0  }, { 0,  0  }, { 0,  0  } },	// 4 DefSats
	{	{ 1, -1  }, { 1,  1  }, { 2,  0  }, { -1, -1 },
		{ -1, 1  }, { 0,  0  }, { 0,  0  }, { 0,  0  }, { 0,  0  } },	// 5 DefSats
	{	{ 1, -1  }, { 1,  0  }, { 1,  1  }, { -1, -1 },
		{ -1, 0  }, { -1, 1  }, { 0,  0  }, { 0,  0  }, { 0,  0  } },	// 6 DefSats
	{	{ 1, -1  }, { 2,  0  }, { 1,  0  }, { 1,  1  },
		{ -1, -1 }, { -1, 0  }, { -1, 1  }, { 0,  0  }, { 0,  0  } },	// 7 DefSats
	{	{ 1, -1  }, { 1,  0  }, { 1,  1  }, { 0,  1  },
		{ -1, 1  }, { -1, 0  }, { -1, -1 }, { 0, -1  }, { 0,  0  } }	// 8 DefSats
};

void tTeam8::mCreateShipsForTeam()
{
	char shipName[16];

	SectorAssaultData	sad;
	int					i;

	sad.Load();

	int32	gridX, origGridX;
	int32	gridY, origGridY;
	fMissionInfo->mGetGridPosition('G', &origGridX, &origGridY);

	for (i = 0; i < sad.mGetDefSats(); i++)
	{
		char customName[32];

		gridX = origGridX + defOffsets[sad.mGetDefSats()][i].offGX;
		gridY = origGridY + defOffsets[sad.mGetDefSats()][i].offGY;

		sprintf(shipName, "%c-DEF", gBaseRace);
		sprintf(customName, "DefSat %d", i+1);

		mCreateShip( typeid( tShipInfo ),
				 shipName,
				 kStartPosition_Specified,
				 kNoMetaShipID,
				 800+i,
				 gridX, gridY, origGridX, origGridY,
				 customName, // shipScriptDescription.fCustomName.c_str(),
				 static_cast< eShipOptions >( kDefaultShipOptions | kCanBeCarrier ) );
	}
}

void tTeam8::mTeamSetupComplete()
{
	tTeamInfo::mTeamSetupComplete();
}


