#include "sysbaseenums.h"


typedef struct t_ValidWeaponArcs
{
	eShipSystemType		weaponType;
	char *				validArcs[32];
} ValidWeaponArcs;

#ifndef _define_vwa

extern ValidWeaponArcs	vwa_ships[];
extern ValidWeaponArcs	vwa_bases[];
extern ValidWeaponArcs	vwa_pfs[];

#else

ValidWeaponArcs	vwa_ships[] =
{
	{	kShipSystemPhoton,			{ "LS", "RS", "FA", "RA", "FARA", "FLL", "LLR", "FLL", "FRR", "NONE" } },
	{	kShipSystemHeavyPhoton,		{ "LS", "RS", "FA", "RA", "FARA", "FLL", "LLR", "FLL", "FRR", "NONE" } },
	{	kShipSystemDisruptor1,		{ "FA", "RA", "LS", "RS", "FX", "RX", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemDisruptor2,		{ "FA", "RA", "LS", "RS", "FX", "RX", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemDisruptor3,		{ "FA", "RA", "LS", "RS", "FX", "RX", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemDisruptor4,		{ "FA", "RA", "LS", "RS", "FX", "RX", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemHeavyDisruptor,	{ "FA", "RA", "LS", "RS", "FX", "RX", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemFusion,			{ "FA", "RA", "FH", "RS", "LS", "RH", "FAR", "FAL", "FRR", "FLL", "NONE" } },
	{	kShipSystemHellbore,		{ "ALL", "FA", "RA", "FH", "RH", "FAR", "FAL", "FRR", "FLL", "NONE" } },

	{	kShipSystemPlasmaR,			{ "FA", "FH", "NONE" } },
	{	kShipSystemPlasmaS,			{ "FA", "FRR", "FLL", "FAR", "FAL", "LLR", "RRR", "RA", "FH", "RH", "RP", "LP", "LS", "RS", "NONE" } },
	{	kShipSystemPlasmaG,			{ "FA", "FRR", "FLL", "FAR", "FAL", "LLR", "RRR", "RA", "FH", "RH", "RP", "LP", "LS", "RS", "NONE" } },
	{	kShipSystemPlasmaF,			{ "FA", "FRR", "FLL", "FAR", "FAL", "LLR", "RRR", "RA", "FH", "RH", "RP", "LP", "LS", "RS", "NONE" } },
	{	kShipSystemPlasmaI,			{ "LLR", "RRR", "NONE" } },
	{	kShipSystemPlasmaD,			{ "ALL", "RS", "LS", "FH", "RH", "NONE" } },
	{	kShipSystemPlasmaE,			{ "LP", "RP", "FA", "FH", "NONE" } },
	{	kShipSystemPlasmaX,			{ "FA", "FRR", "FLL", "FAR", "FAL", "LLR", "RRR", "RA", "FH", "RH", "RP", "LP", "LS", "RS", "NONE" } },

	{	kShipSystemESG,				{ "ALL", "NONE" } },
	{	kShipSystemESGLance,		{ "FA", "FAL", "FAR", "FRR", "FLL", "NONE" } },
	{	kShipSystemPPD,				{ "FA", "RA", "NONE" } },

	{	kShipSystemDroneRackA,		{ "1", "2", "3", "NONE" } },
	{	kShipSystemDroneRackB,		{ "1", "2", "3", "NONE" } },
	{	kShipSystemDroneRackC,		{ "1", "2", "3", "NONE" } },
	{	kShipSystemDroneRackD,		{ "1", "2", "3", "NONE" } },
	{	kShipSystemDroneRackE,		{ "1", "2", "3", "NONE" } },
	{	kShipSystemDroneRackF,		{ "1", "2", "3", "NONE" } },
	{	kShipSystemDroneRackG,		{ "1", "2", "3", "NONE" } },
	{	kShipSystemDroneRackH,		{ "1", "2", "3", "NONE" } },
	{	kShipSystemDroneRackMIRV,	{ "1", "2", "3", "NONE" } },

	{	kShipSystemPhaser1,			{ "ALL", "LP", "RP", "KFX", "RW", "LW", "RRR", "LLR", "FA", "RA", "FRRX", "FLLX", "LS", "RS", "FX", "RX", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemPhaser2,			{ "ALL", "LP", "RP", "KFX", "RW", "LW", "RRR", "LLR", "FA", "RA", "LS", "RS", "FX", "RX", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemPhaser3,			{ "ALL", "LP", "RP", "LWX", "RWX", "KFX", "RW", "LW", "RRR", "LLR", "FA", "RA", "LS", "RS", "FX", "RX", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemPhaserG,			{ "ALL", "RW", "LW", "RRR", "LLR", "FA", "RA", "LS", "RS", "FX", "RX", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemPhaser4,			{ "ALL", "NONE" } },
	{	kShipSystemPhaserA,			{ "ALL", "RS", "LS", "FA", "RA", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemPhaserB,			{ "ALL", "RS", "LS", "FA", "RA", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemPhaserX,			{ "ALL", "KFX", "RW", "LW", "RRR", "LLR", "FA", "RA", "FRRX", "FLLX", "LS", "RS", "FX", "RX", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemPhaserG2,		{ "ALL", "RW", "LW", "RRR", "LLR", "FA", "RA", "FRRX", "FLLX", "LS", "RS", "FX", "RX", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },

	{	kShipSystemADD6,			{ "1", "2", "3", "NONE" } },
	{	kShipSystemADD12,			{ "1", "2", "3", "NONE" } },

	{	kShipSystemMauler,			{ "MLR", "NONE" } },

	{	kNoShipSystemType,			{ "NONE" } }
};

ValidWeaponArcs	vwa_bases[] =
{
	{	kShipSystemPhoton,			{ "ALL", "FAL", "FAR", "RAL", "FLL", "FX", "RX", "RS", "LS", "FH", "RH", "NONE" } },
	{	kShipSystemHeavyPhoton,		{ "ALL", "FAL", "FAR", "RAL", "FLL", "FX", "RX", "RS", "LS", "FH", "RH", "NONE" } },
	{	kShipSystemDisruptor1,		{ "ALL", "FA", "FLL", "FX", "RX", "RS", "LS", "FH", "RH", "NONE" } },
	{	kShipSystemDisruptor2,		{ "ALL", "FA", "FLL", "FX", "RX", "RS", "LS", "FH", "RH", "NONE" } },
	{	kShipSystemDisruptor3,		{ "ALL", "FA", "FLL", "FX", "RX", "RS", "LS", "FH", "RH", "NONE" } },
	{	kShipSystemDisruptor4,		{ "ALL", "FA", "FAL", "RAL", "FLL", "FX", "RX", "RS", "LS", "FH", "RH", "NONE" } },
	{	kShipSystemHeavyDisruptor,	{ "ALL", "FA", "RA", "LS", "RS", "FX", "RX", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemFusion,			{ "ALL", "FA", "FAL", "RAL", "FLL", "FX", "RX", "RS", "LS", "FH", "RH", "NONE" } },
	{	kShipSystemHellbore,		{ "ALL", "FA", "FAL", "RAL", "FLL", "FX", "RX", "RS", "LS", "FH", "RH", "NONE" } },

	{	kShipSystemPlasmaR,			{ "ALL", "FAL", "RAL", "FLL", "FX", "RX", "FA", "RA", "RS", "LS", "FH", "RH", "NONE" } },
	{	kShipSystemPlasmaS,			{ "ALL", "FAL", "RAL", "FLL", "FX", "RX", "FA", "RA", "RS", "LS", "FH", "RH", "NONE" } },
	{	kShipSystemPlasmaG,			{ "ALL", "FAL", "RAL", "FLL", "FX", "RX", "FA", "RA", "RS", "LS", "FH", "RH", "NONE" } },
	{	kShipSystemPlasmaF,			{ "ALL", "FAL", "RAL", "FLL", "FX", "RX", "FA", "RA", "RS", "LS", "FH", "RH", "NONE" } },
	{	kShipSystemPlasmaI,			{ "NONE" } },
	{	kShipSystemPlasmaD,			{ "ALL", "RS", "LS", "FH", "RH", "NONE" } },
	{	kShipSystemPlasmaE,			{ "ALL", "FAL", "RAL", "FLL", "FX", "RX", "FA", "RA", "RS", "LS", "FH", "RH", "NONE" } },
	{	kShipSystemPlasmaX,			{ "ALL", "FAL", "RAL", "FLL", "FX", "RX", "FA", "RA", "RS", "LS", "FH", "RH", "NONE" } },

	{	kShipSystemESG,				{ "ALL", "NONE" } },
	{	kShipSystemESGLance,		{ "ALL", "FAL", "FAR", "RAL", "FLL", "FX", "RX", "RS", "LS", "FH", "RH", "NONE" } },
	{	kShipSystemPPD,				{ "FA", "RA", "FX", "RX", "RS", "LS", "FAL", "RH", "FH", "ALL", "NONE" } },

	{	kShipSystemDroneRackA,		{ "1", "2", "3", "NONE" } },
	{	kShipSystemDroneRackB,		{ "1", "2", "3", "NONE" } },
	{	kShipSystemDroneRackC,		{ "1", "2", "3", "NONE" } },
	{	kShipSystemDroneRackD,		{ "1", "2", "3", "NONE" } },
	{	kShipSystemDroneRackE,		{ "1", "2", "3", "NONE" } },
	{	kShipSystemDroneRackF,		{ "1", "2", "3", "NONE" } },
	{	kShipSystemDroneRackG,		{ "1", "2", "3", "NONE" } },
	{	kShipSystemDroneRackH,		{ "1", "2", "3", "NONE" } },
	{	kShipSystemDroneRackMIRV,	{ "1", "2", "3", "NONE" } },

	{	kShipSystemPhaser1,			{ "ALL", "KFX", "RW", "LW", "RRR", "LLR", "FA", "RA", "FRRX", "FLLX", "LS", "RS", "FX", "RX", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemPhaser2,			{ "ALL", "KFX", "RW", "LW", "RRR", "LLR", "FA", "RA", "LS", "RS", "FX", "RX", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemPhaser3,			{ "ALL", "LWX", "RWX", "KFX", "RW", "LW", "RRR", "LLR", "FA", "RA", "LS", "RS", "FX", "RX", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemPhaserG,			{ "ALL", "RW", "LW", "RRR", "LLR", "FA", "RA", "LS", "RS", "FX", "RX", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemPhaser4,			{ "ALL", "KFX", "RW", "LW", "RRR", "LLR", "FA", "RA", "FRRX", "FLLX", "LS", "RS", "FX", "RX", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemPhaserA,			{ "ALL", "RS", "LS", "FA", "RA", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemPhaserB,			{ "ALL", "RS", "LS", "FA", "RA", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemPhaserX,			{ "ALL", "KFX", "RW", "LW", "RRR", "LLR", "FA", "RA", "FRRX", "FLLX", "LS", "RS", "FX", "RX", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemPhaserG2,		{ "ALL", "RW", "LW", "RRR", "LLR", "FA", "RA", "FRRX", "FLLX", "LS", "RS", "FX", "RX", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },

	{	kShipSystemADD6,			{ "1", "2", "3", "NONE" } },
	{	kShipSystemADD12,			{ "1", "2", "3", "NONE" } },

	{	kShipSystemMauler,			{ "NONE" } },

	{	kNoShipSystemType,			{ "NONE" } }
};

ValidWeaponArcs	vwa_pfs[] =
{
	{	kShipSystemPhoton,			{ "ALL", "FAL", "RAL", "FLL", "FX", "RX", "RS", "LS", "FH", "RH", "NONE" } },
	{	kShipSystemHeavyPhoton,		{ "ALL", "LS", "RS", "FA", "RA", "FARA", "FLL", "LLR", "FLL", "FRR", "NONE" } },
	{	kShipSystemDisruptor1,		{ "ALL", "FA", "FLL", "FX", "RX", "RS", "LS", "FH", "RH", "NONE" } },
	{	kShipSystemDisruptor2,		{ "ALL", "FA", "FLL", "FX", "RX", "RS", "LS", "FH", "RH", "NONE" } },
	{	kShipSystemDisruptor3,		{ "ALL", "FA", "FLL", "FX", "RX", "RS", "LS", "FH", "RH", "NONE" } },
	{	kShipSystemDisruptor4,		{ "ALL", "FA", "FLL", "FX", "RX", "RS", "LS", "FH", "RH", "NONE" } },
	{	kShipSystemHeavyDisruptor,	{ "ALL", "FA", "RA", "LS", "RS", "FX", "RX", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemFusion,			{ "ALL", "FLL", "FX", "RX", "RS", "LS", "FH", "RH", "NONE" } },
	{	kShipSystemHellbore,		{ "ALL", "FLL", "FX", "RX", "RS", "LS", "FH", "RH", "NONE" } },

	{	kShipSystemPlasmaR,			{ "ALL", "FA", "RA", "FLL", "FX", "RX", "RS", "LS", "RP", "LP", "FH", "RH", "NONE" } },
	{	kShipSystemPlasmaS,			{ "ALL", "FA", "RA", "FLL", "FX", "RX", "RS", "LS", "RP", "LP", "FH", "RH", "NONE" } },
	{	kShipSystemPlasmaG,			{ "ALL", "FA", "RA", "FLL", "FX", "RX", "RS", "LS", "RP", "LP", "FH", "RH", "NONE" } },
	{	kShipSystemPlasmaF,			{ "ALL", "FA", "RA", "FLL", "FX", "RX", "RS", "LS", "RP", "LP", "FH", "RH", "NONE" } },
	{	kShipSystemPlasmaI,			{ "NONE" } },
	{	kShipSystemPlasmaD,			{ "ALL", "RS", "LS", "FH", "RH", "NONE" } },
	{	kShipSystemPlasmaE,			{ "FA", "FH", "NONE" } },
	{	kShipSystemPlasmaX,			{ "FA", "FRR", "FLL", "FAR", "FAL", "LLR", "RRR", "RA", "FH", "RH", "RP", "LP", "LS", "RS", "NONE" } },

	{	kShipSystemESG,				{ "ALL", "NONE" } },
	{	kShipSystemESGLance,		{ "NONE" } },
	{	kShipSystemPPD,				{ "NONE" } },

	{	kShipSystemDroneRackA,		{ "1", "2", "3", "NONE" } },
	{	kShipSystemDroneRackB,		{ "1", "2", "3", "NONE" } },
	{	kShipSystemDroneRackC,		{ "1", "2", "3", "NONE" } },
	{	kShipSystemDroneRackD,		{ "1", "2", "3", "NONE" } },
	{	kShipSystemDroneRackE,		{ "1", "2", "3", "NONE" } },
	{	kShipSystemDroneRackF,		{ "1", "2", "3", "NONE" } },
	{	kShipSystemDroneRackG,		{ "1", "2", "3", "NONE" } },
	{	kShipSystemDroneRackH,		{ "1", "2", "3", "NONE" } },
	{	kShipSystemDroneRackMIRV,	{ "1", "2", "3", "NONE" } },

	{	kShipSystemPhaser1,			{ "ALL", "KFX", "RW", "LW", "RRR", "LLR", "FA", "RA", "FRRX", "FLLX", "LS", "RS", "FX", "RX", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemPhaser2,			{ "ALL", "KFX", "RW", "LW", "RRR", "LLR", "FA", "RA", "LS", "RS", "FX", "RX", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemPhaser3,			{ "ALL", "LWX", "RWX", "KFX", "RW", "LW", "RRR", "LLR", "FA", "RA", "LS", "RS", "FX", "RX", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemPhaserG,			{ "ALL", "RW", "LW", "RRR", "LLR", "FA", "RA", "LS", "RS", "FX", "RX", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemPhaser4,			{ "ALL", "NONE" } },
	{	kShipSystemPhaserA,			{ "ALL", "RS", "LS", "FA", "RA", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemPhaserB,			{ "ALL", "RS", "LS", "FA", "RA", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemPhaserX,			{ "ALL", "KFX", "RW", "LW", "RRR", "LLR", "FA", "RA", "FRRX", "FLLX", "LS", "RS", "FX", "RX", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },
	{	kShipSystemPhaserG2,		{ "ALL", "RW", "LW", "RRR", "LLR", "FA", "RA", "FRRX", "FLLX", "LS", "RS", "FX", "RX", "FH", "RH", "FAL", "FAR", "FLL", "FRR", "RAL", "RAR", "FHR", "FHL", "NONE" } },

	{	kShipSystemADD6,			{ "1", "2", "3", "NONE" } },
	{	kShipSystemADD12,			{ "1", "2", "3", "NONE" } },

	{	kShipSystemMauler,			{ "NONE" } },

	{	kNoShipSystemType,			{ "NONE" } }
};

#endif

/*		kShipSystemADD6,
	kShipSystemADD12,
	kShipSystemADD30,
	kShipSystemArmor,
	kShipSystemHullGroup,
	kShipSystemForwardHull,
	kShipSystemCenterHull,
	kShipSystemAftHull,
	kShipSystemCargo,
	kShipSystemBarracks,
	kShipSystemEngineGroup,
	kShipSystemLeftWarp,
	kShipSystemRightWarp,
	kShipSystemCenterWarp,
	kShipSystemImpulse,
	kShipSystemAPR,
	kShipSystemBattery,
	kShipSystemBridgeGroup,
	kShipSystemBridge,
	kShipSystemFlagBridge,
	kShipSystemEmergencyBridge,
	kShipSystemSecurity,
	kShipSystemLab,
	kShipSystemTransporters,
	kShipSystemTractor,
	kShipSystemMechTractors,
	kShipSystemTractors,
	kShipSystemSensorGroup,
	kShipSystemSensors,
	kShipSystemScanners,
	kShipSystemSpecialSensors,
	kShipSystemDamageControlGroup,
	kShipSystemDamageControl,
	kShipSystemInternalRepair,
	kShipSystemExcessDamage,
	kShipSystemAuxilliaryControl,
	kShipSystemOfficerGroup,
	kShipSystemEngineeringOfficer,
	kShipSystemSecurityOfficer,
	kShipSystemWeaponsOfficer,
	kShipSystemHelmOfficer,
	kShipSystemCommunicationsOfficer,
	kShipSystemScienceOfficer,
	kShipSystemCaptainOfficer,

	kShipSystemPhaserA,
	kShipSystemPhaserB,
	kShipSystemPhaserX,
	kShipSystemPhaserG2,
	kShipSystemESGLance,
	kShipSystemPhotonHeavy,
	kShipSystemDisruptorHeavy,
	kShipSystemMIRV,
	kShipSystemPlasmaFast,	// X
	kShipSystemPlasmaSnare,	// E
	kShipSystemMauler,
	}
	*/
	
