#include "stdafx.h"
#include "ShipList.h"

int main(int argc, char* argv[])
{
	ShipList	shipList;

	printf("ModelCheck v1.00\nby MagnumMan-iCoP (James E. King, III)\n\n");
	printf("Loading the spec files...\n");
	if (!shipList.CreateMaster("C:\\shiplist-kmb5.txt", "C:\\ftrlist-op4.txt"))
	{
		printf("error: Could not load shiplist.txt data.\n");
		exit(1);
	}

	printf("\nVerifying all models are accessible...\n");

	/*
	 * iter is an iterator into the list here... so we walk
	 * down the "old ship spec file" looking for changes
	 * in the new one.
	 *
	 * Then we walk down the "new ship spec file" and look
	 * for ships that are missing in the old one - i.e. new
	 * ships.
	 */

	{
		SHIP_LIST_ITER(shipList)

			std::string str;
		//	shipList.FindSpecsDirectory(false, str);
		//	str.erase(str.size() - 13, 13);

			str = "C:\\Program Files\\Taldren\\StarFleet Command - Orion Pirates - Beta 1\\";

			str.append(iter->geometry);
			FILE *fp = fopen(str.c_str(), "r");
			if (!fp)
				printf("ERROR: Model for ship %s cannot be located.\n", iter->shipCode.c_str());
			else
				fclose(fp);

		SHIP_LIST_ITER_END
	}

	{
		SHIP_LIST_ITER(shipList.fighters_and_pfs)

			std::string str;
		//	shipList.FindSpecsDirectory(false, str);
		//	str.erase(str.size() - 13, 13);

			str = "C:\\Program Files\\Taldren\\StarFleet Command - Orion Pirates - Beta 1\\";

			str.append(iter->geometry);
			FILE *fp = fopen(str.c_str(), "r");
			if (!fp)
				printf("ERROR: Model for ship %s cannot be located.\n", iter->shipCode.c_str());
			else
				fclose(fp);

		SHIP_LIST_ITER_END
	}

	return 0;
}
